; $Id: cont.scm,v 1.3 2006/12/12 16:02:03 schimans Exp $

; Continuous functions
; ====================

; To be added to tensor.scm: Constructor and accessors for tensor
; types:

; (define (make-tensor-type type1 type2)
;   (make-alg "tensor" type1 type2))

; ; (type-to-string (make-tensor-type (py "pos") (py "boole")))

; (define (tensor-form-to-arg-type tensor-type)
;   (car (alg-form-to-types tensor-type)))

; (define (tensor-form-to-val-type tensor-type)
;   (cadr (alg-form-to-types tensor-type)))

; ; (type-to-string
; ;  (tensor-form-to-arg-type (make-tensor-type (py "pos") (py "boole"))))

; ; (type-to-string
; ;  (tensor-form-to-val-type (make-tensor-type (py "pos") (py "boole"))))

; (define (mk-tensor-type x . rest) ;associates to the right
;   (if (null? rest)
;       x
;       (make-alg "tensor" x (apply mk-tensor-type rest))))

; ; (type-to-string (mk-tensor-type (py "pos") (py "pos") (py "boole")))

; (define (types-to-fst-term type1 type2) ;of type tau1 tensor tau2 => tau1
;   (let* ((const (pconst-name-to-pconst "tensorFst"))
; 	 (tvars (const-to-tvars const))
; 	 (subst (make-substitution tvars (list type1 type2))))
;     (make-term-in-const-form
;      (const-substitute const subst #f))))

; (define (types-to-snd-term type1 type2)
;   (let* ((const (pconst-name-to-pconst "tensorSnd"))
; 	 (tvars (const-to-tvars const))
; 	 (subst (make-substitution tvars (list type1 type2))))
;     (make-term-in-const-form
;      (const-substitute const subst #f))))

; ; (term-to-string (types-to-snd-term  (py "pos") (py "boole")))
; ; (type-to-string (term-to-type (types-to-snd-term  (py "pos") (py "boole"))))

; (define (index-and-types-to-proj-term i . types)
;   (if (< (length types) 2)
;       (myerror "index-and-types-to-proj-term" ">= 2 types expected"
; 	       (map type-to-string types)))
;   (if (not (< i (length types)))
;       (myerror "index-and-types-to-proj-term" "out of range"
; 	       i "for" (map type-to-string types)))
;   (let* ((type0 (car types))
; 	 (rest-types (cdr types))
; 	 (fst-term (types-to-fst-term type0 (apply mk-tensor-type rest-types)))
; 	 (snd-term
; 	  (types-to-snd-term type0 (apply mk-tensor-type rest-types))))
;     (cond
;      ((zero? i) fst-term)
;      ((and (= 1 i) (= 2 (length types))) snd-term)
;      (else ;lambda var.prev(snd-term var)
;       (let* ((var (type-to-new-var (apply mk-tensor-type types)))
; 	     (prev (apply index-and-types-to-proj-term
; 			  (cons (- i 1) rest-types))))
; 	(make-term-in-abst-form
; 	 var (make-term-in-app-form
; 	      prev (make-term-in-app-form
; 		    snd-term (make-term-in-var-form var)))))))))

; (term-to-string (index-and-types-to-proj-term 0 (py "pos") (py "boole")))
; (type-to-string
;  (term-to-type (index-and-types-to-proj-term 0 (py "pos") (py "boole"))))
; (term-to-string (index-and-types-to-proj-term 1 (py "pos") (py "boole")))
; (type-to-string
;  (term-to-type (index-and-types-to-proj-term 1 (py "pos") (py "boole"))))

; (term-to-string (index-and-types-to-proj-term
; 		 1 (py "pos") (py "boole") (py "boole")))
; (type-to-string
;  (term-to-type (index-and-types-to-proj-term
; 		1 (py "pos") (py "boole") (py "boole"))))
      
; (term-to-string (index-and-types-to-proj-term
; 		 2 (py "pos") (py "boole") (py "boole")))
; (type-to-string
;  (term-to-type (index-and-types-to-proj-term
; 		2 (py "pos") (py "boole") (py "boole"))))
      
; (term-to-string (index-and-types-to-proj-term
; 		 3 (py "pos") (py "boole") (py "boole")))

; (term-to-string
;  (nt (make-term-in-app-form
;       (index-and-types-to-proj-term 0 (py "pos") (py "boole") (py "boole"))
;       (make-term-in-var-form
;        (type-to-new-var
; 	(mk-tensor-type (py "pos") (py "boole") (py "boole")))))))

; (term-to-string
;  (nt (make-term-in-app-form
;       (index-and-types-to-proj-term 1 (py "pos") (py "boole") (py "boole"))
;       (make-term-in-var-form
;        (type-to-new-var
; 	(mk-tensor-type (py "pos") (py "boole") (py "boole")))))))

; (term-to-string
;  (nt (make-term-in-app-form
;       (index-and-types-to-proj-term 2 (py "pos") (py "boole") (py "boole"))
;       (make-term-in-var-form
;        (type-to-new-var
; 	(mk-tensor-type (py "pos") (py "boole") (py "boole")))))))

; 04-01-24
; Algebraic structures (`hierarchy') versus concrete algebras.

; To develop general group theory, take a type variable alpha (the
; type of the group elements) and a predicate variable G of arity
; alpha (the property to be an element of the group).  Take a binary
; predicate variable == and formulate as its properties that it is an
; equivalence relation on G.  Take a binary function variable o
; (composition), a unary function variable inv (inverse) and a
; variable e (unit), and formulate as their properties that G is
; closed under them, compatibility with ==, and finally the ordinary
; group axioms.  For equality reasoning we cannot use computation or
; rewrite rules (there are no program constants), but must use simp
; instead.  To apply general results for a concrete group, use proof
; substitution.

; For a concrete algebra (`record') the underlying data type is a free
; algebra with one non-iterable constructor.  The destructors are
; program constants and come with the obvious computation rules.  They
; should have informative names (`fields').  In a second step the
; actual elements of the concrete algebra are singled out by means of
; a (formally) inductively defined predicate, which in fact is
; explicitely defined by the required properties of the field
; components.

; Example: continuous functions.

(add-alg
 "cont"
 (list "ContConstr" "rat=>rat=>(rat=>pos=>rat)=>(pos=>pos)=>(pos=>pos)=>cont"))

(add-var-name "h" (py "rat=>pos=>rat"))
(add-var-name "al" (py "pos=>pos"))
(add-var-name "om" (py "pos=>pos"))

(add-program-constant "ContDoml" (py "cont=>rat") 1 'const 1)

(add-token
 "doml"
 'postfix-op
 (lambda (x)
   (mk-term-in-app-form
    (make-term-in-const-form (pconst-name-to-pconst "ContDoml"))
    x)))

(add-display
 (py "rat")
 (lambda (x)
   (let ((op (term-in-app-form-to-final-op x))
	 (args (term-in-app-form-to-args x)))
     (if (and (term-in-const-form? op)
	      (string=? "ContDoml"
			(const-to-name (term-in-const-form-to-const op)))
	      (= 1 (length args)))
	 (let ((arg (car args)))
	   (list
	    'postfix-op "doml"
	    (term-to-token-tree arg)))
	 #f))))
 
(add-computation-rule (pt "(ContConstr a0 b0 h al om)doml") (pt "a0"))

(add-program-constant "ContDomr" (py "cont=>rat") 1 'const 1)

(add-token
 "domr"
 'postfix-op
 (lambda (x)
   (mk-term-in-app-form
    (make-term-in-const-form (pconst-name-to-pconst "ContDomr"))
    x)))

(add-display
 (py "rat")
 (lambda (x)
   (let ((op (term-in-app-form-to-final-op x))
	 (args (term-in-app-form-to-args x)))
     (if (and (term-in-const-form? op)
	      (string=? "ContDomr"
			(const-to-name (term-in-const-form-to-const op)))
	      (= 1 (length args)))
	 (let ((arg (car args)))
	   (list
	    'postfix-op "domr"
	    (term-to-token-tree arg)))
	 #f))))
 
(add-computation-rule (pt "(ContConstr a0 b0 h al om)domr") (pt "b0"))

(add-program-constant "ContApprox" (py "cont=>rat=>pos=>rat") 1 'const 1)

(add-token
 "approx"
 'postfix-op
 (lambda (x)
   (mk-term-in-app-form
    (make-term-in-const-form (pconst-name-to-pconst "ContApprox"))
    x)))

(add-display
 (py "rat=>pos=>rat")
 (lambda (x)
   (let ((op (term-in-app-form-to-final-op x))
	 (args (term-in-app-form-to-args x)))
     (if (and (term-in-const-form? op)
	      (string=? "ContApprox"
			(const-to-name (term-in-const-form-to-const op)))
	      (= 1 (length args)))
	 (let ((arg (car args)))
	   (list
	    'postfix-op "approx"
	    (term-to-token-tree arg)))
	 #f))))
 
(add-computation-rule (pt "(ContConstr a0 b0 h al om)approx") (pt "h"))

(add-program-constant "ContuMod" (py "cont=>pos=>pos") 1 'const 1)

(add-token
 "uMod"
 'postfix-op
 (lambda (x)
   (mk-term-in-app-form
    (make-term-in-const-form (pconst-name-to-pconst "ContuMod"))
    x)))

(add-display
 (py "pos=>pos")
 (lambda (x)
   (let ((op (term-in-app-form-to-final-op x))
	 (args (term-in-app-form-to-args x)))
     (if (and (term-in-const-form? op)
	      (string=? "ContuMod"
			(const-to-name (term-in-const-form-to-const op)))
	      (= 1 (length args)))
	 (let ((arg (car args)))
	   (list
	    'postfix-op "uMod"
	    (term-to-token-tree arg)))
	 #f))))
 
(add-computation-rule (pt "(ContConstr a0 b0 h al om)uMod") (pt "al"))

(add-program-constant "ContuModCont" (py "cont=>pos=>pos") 1 'const 1)

(add-token
 "uModCont"
 'postfix-op
 (lambda (x)
   (mk-term-in-app-form
    (make-term-in-const-form (pconst-name-to-pconst "ContuModCont"))
    x)))

(add-display
 (py "pos=>pos")
 (lambda (x)
   (let ((op (term-in-app-form-to-final-op x))
	 (args (term-in-app-form-to-args x)))
     (if (and (term-in-const-form? op)
	      (string=? "ContuModCont"
			(const-to-name (term-in-const-form-to-const op)))
	      (= 1 (length args)))
	 (let ((arg (car args)))
	   (list
	    'postfix-op "uModCont"
	    (term-to-token-tree arg)))
	 #f))))
 
(add-computation-rule (pt "(ContConstr a0 b0 h al om)uModCont") (pt "om"))

(add-var-name "f" (make-alg "cont"))

; Now the (formally inductive) definition of Cont

(add-ids
 (list (list "Cont" (make-arity (make-alg "cont"))))
 '("all a0,b0,h,al,om.
     (all a.a0<=a -> a<=b0 -> Cauchy(h a)al) -> 
     (all a,b,k,n.a0<=a -> a<=b0 -> a0<=b -> b<=b0 ->
                  al k<=n -> 
                  abs(a-b)<=(1#exp 2(om k)) ->
                  abs(h a n-h b n)<=(1#exp 2 k)) ->
     (all m,n.m<=n -> al m<=al n) ->
     (all m,n.m<=n -> om m<=om n) ->
     Cont(ContConstr a0 b0 h al om)" "ContIntro"))

; Example of a continuous function: a^2-2 on [1,2]

(term-to-string
  (simp-term
   (nt (pt "(ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))approx (14#10) 1"))))

; Now the properties of Cont.

; (set-goal
;  (pf "all f.
;        (all a.f doml<=a -> a<=f domr -> Cauchy(f approx a)(f uMod)) -> 
;        (all a,b,k,n.f doml<=a -> a<=f domr -> f doml<=b -> b<=f domr ->
;                     f uMod k<=n -> 
;                     abs(a-b)<=(1#exp 2(f uModCont k)) ->
;                     abs(f approx a n-f approx b n)<=(1#exp 2 k)) ->
;        (all m,n.m<=n -> f uMod m<=f uMod n) ->
;        (all m,n.m<=n -> f uModCont m<=f uModCont n) ->
;        Cont f"))
; (ind)
; (strip)
; (intro 0)
; (auto 1)
; (save "ContIntro")

(set-goal (pf "all f.Cont f -> all a.f doml<=a -> a<=f domr ->
                                     Cauchy(f approx a)(f uMod)"))
(ind)
(assume "a0" "b0" "h" "al" "om")
(elim)
(search)
(save "ContElim1")

(set-goal (pf "all f.Cont f ->
        all a,b,k,n.f doml<=a -> a<=f domr -> f doml<=b -> b<=f domr ->
                    f uMod k<=n -> 
                    abs(a-b)<=(1#exp 2(f uModCont k)) ->
                    abs(f approx a n-f approx b n)<=(1#exp 2 k)"))
(ind)
(assume "a0" "b0" "h" "al" "om")
(elim)
(search)
(save "ContElim2")

(set-goal (pf "all f.Cont f -> all m,n.m<=n -> f uMod m<=f uMod n"))
(ind)
(assume "a0" "b0" "h" "al" "om")
(elim)
(search)
(save "ContElim3")

(set-goal (pf "all f.Cont f -> all m,n.m<=n -> f uModCont m<=f uModCont n"))
(ind)
(assume "a0" "b0" "h" "al" "om")
(elim)
(search)
(save "ContElim4")

; All this could be done automatically by evaluating

; (add-record
;  "Cont" "f"
;  (list "doml" "rat")
;  (list "domr" "rat")
;  (list "approx" "rat=>pos=>rat")
;  (list "uMod" "pos=>pos")
;  (list "uModCont" "pos=>pos")
;  "all a.f doml<=a -> a<=f domr -> Cauchy(f approx a)(f uMod)"
;  "all a,b,k,n.f doml<=a -> a<=f domr -> f doml<=b -> b<=f domr ->
;               f uMod k<=n -> 
;               abs(a-b)<=(1#exp 2(f uModCont k)) ->
;               abs(f approx a n-f approx b n)<=(1#exp 2 k))"
;  "all m,n.m<=n -> f uMod m<=f uMod n"
;  "all m,n.m<=n -> f uModCont m<=f uModCont n")

; However, for the time being it is done by hand.

; Recall the intermediate value theorem, now written as follows:

; (pf "all f,M.Cont f -> f app f doml<=0 -> 0<=f app f domr ->
;      (all x,y,k.RealLt x y k -> RealLt(f app x)(f app y)(M k)) -> 
;      ex z.Real z & f app z===0")

; We aim at an application notation: (f x) instead of (f app x), so

; (pf "all f,M.Cont f -> f(f doml)<=0 -> 0<=f(f domr) ->
;      (all x,y,k.RealLt x y k -> RealLt(f x)(f y)(M k)) -> 
;      ex z.Real z & f z===0")

; For an application notation (f x) we must from (x seq) and (x mod)
; produce the real whose Cauchy sequence is [n]f approx(x seq n)n and
; whose modulus is \max(\alpha_f(k+2), \alpha(\omega_f(k+1)-1)) or
; formally [k]f uMod(S(S k))max x mod(f uModCont(S
; k)dotminus 1)

; (term-to-string (pt "[n]f approx(x seq n)n"))

; (pp (pt "[k]f uMod(S(S k))max x mod(f uModCont(S k)--1)"))

(define (make-term-in-cont-app-form f x)
  (let ((constr (constr-name-to-constr "RealConstr"))
	(seq-const (pconst-name-to-pconst "RealSeq"))
	(mod-const (pconst-name-to-pconst "RealMod"))			
	(var (type-to-new-var (py "pos"))))
    (mk-term-in-app-form
     (make-term-in-const-form constr)
     (make-term-in-abst-form
      var (mk-term-in-app-form
	   (make-term-in-const-form
	    (pconst-name-to-pconst "ContApprox"))
	   f
	   (mk-term-in-app-form
	    (make-term-in-const-form seq-const)
	    x (make-term-in-var-form var))
	   (make-term-in-var-form var)))
     (make-term-in-abst-form
      var (mk-term-in-app-form
	   (make-term-in-const-form
	    (pconst-name-to-pconst "PosMax"))
	   (mk-term-in-app-form
	    (make-term-in-const-form
	     (pconst-name-to-pconst "ContuMod"))
	    f
	    (make-term-in-app-form
	     (make-term-in-const-form (pconst-name-to-pconst "S"))
	     (make-term-in-app-form
	      (make-term-in-const-form (pconst-name-to-pconst "S"))
	      (make-term-in-var-form var))))
	   (mk-term-in-app-form
	    (make-term-in-const-form mod-const)
	    x
	    (mk-term-in-app-form
	     (make-term-in-const-form (pconst-name-to-pconst "PosMinus"))
	     (mk-term-in-app-form
	      (make-term-in-const-form
	       (pconst-name-to-pconst "ContuModCont"))
	      f
	      (make-term-in-app-form
	       (make-term-in-const-form (pconst-name-to-pconst "S"))
	       (make-term-in-var-form var)))
	     (make-numeric-term 1))))))))

; (pp (nt (make-term-in-cont-app-form (pt "f") (pt "x"))))

(add-new-application
 (lambda (type) (equal? type (make-alg "cont")))
 make-term-in-cont-app-form) 

; A term is in cont-app-form if it is in application form with
; operator RealConstr, with seq field of the form [n]f approx(x seq
; n)n.  It should then be displayed as f x, where f and x can be read
; off.

(define (term-in-cont-app-form? term)
  (and
   (term-in-app-form? term)
   (let ((op (term-in-app-form-to-final-op term))
	 (args (term-in-app-form-to-args term)))
     (and
      (term-in-const-form? op)
      (string=? "RealConstr" (const-to-name (term-in-const-form-to-const op)))
      (= 2 (length args))
      (equal? (py "pos=>pos") (term-to-type (cadr args)))
      (term-in-abst-form? (car args))
      (let* ((var (term-in-abst-form-to-var (car args)))
	     (kernel (term-in-abst-form-to-kernel (car args)))
	     (op1 (term-in-app-form-to-final-op kernel))
	     (args1 (term-in-app-form-to-args kernel)))
	(and
	 (term-in-const-form? op1)
	 (string=? "ContApprox"
		   (const-to-name (term-in-const-form-to-const op1)))
	 (= 3 (length args1))
	 (let ((arg1 (car args1)) ;this is f
	       (arg2 (cadr args1)) ;this is x seq n
	       (arg3 (caddr args1))) ;this is n
	   (and
	    (term-in-var-form? arg3)
	    (equal? var (term-in-var-form-to-var arg3))
	    (let ((op2 (term-in-app-form-to-final-op arg2))
		  (args2 (term-in-app-form-to-args arg2)))
	      (and
	       (term-in-const-form? op2)
	       (string=? "RealSeq"
			 (const-to-name (term-in-const-form-to-const op2)))
	       (= 2 (length args2))
	       (let ((arg21 (car args2)) ;this is x
		     (arg22 (cadr args2))) ;this is n
		 (and
		  (term-in-var-form? arg22)
		  (equal? var (term-in-var-form-to-var arg22))))))))))))))

; (term-in-cont-app-form? (make-term-in-cont-app-form (pt "f") (pt "x")))

(define (term-in-cont-app-form-to-op term)
  (let* ((args (term-in-app-form-to-args term))
	 (kernel (term-in-abst-form-to-kernel (car args)))
	 (args1 (term-in-app-form-to-args kernel)))
    (car args1)))

(define (term-in-cont-app-form-to-arg term)
  (let* ((args (term-in-app-form-to-args term))
	 (kernel (term-in-abst-form-to-kernel (car args)))
	 (args1 (term-in-app-form-to-args kernel))
	 (arg2 (cadr args1)) ;this is x seq n
	 (args2 (term-in-app-form-to-args arg2)))
    (car args2)))

; (term-in-cont-app-form-to-op (make-term-in-cont-app-form (pt "f") (pt "x")))
; (term-in-cont-app-form-to-arg (make-term-in-cont-app-form (pt "f") (pt "x")))

(add-display
 (py "real")
 (lambda (x)
   (if (term-in-cont-app-form? x)
       (list 'appterm ""
	     (term-to-token-tree
	      (term-in-cont-app-form-to-op x))
	     (term-to-token-tree
	      (int-term-to-pos-term
	       (rat-term-to-int-term
		(real-term-to-rat-term
		 (term-in-cont-app-form-to-arg x))))))
       #f)))

; (term-to-string (pt "n+0"))
; (term-to-string (pt "f x"))
; (term-to-string (pt "(f x)mod"))
; (term-to-string (nt (pt "(f x)seq")))
; (term-to-string (nt (pt "(f x)mod")))

(add-global-assumption
 "ContReal"
 (pf "all f,x.Cont f -> Real x -> f doml<<=x -> x<<=f domr -> Real(f x)"))

(add-global-assumption
 "ContRealRat"
 (pf "all f,c.Cont f -> f doml<<=c -> c<<=f domr -> Real(f c)"))

; Approximate splitting principle.

; We will make use of some lemmata, that can be proved easily:

(add-global-assumption
 "RealLeCrit"
 (pf "all x,y,n0.Real x -> Real y ->
                 (all n.n0<=n -> x seq n<=y seq n) -> x<<=y"))

; (remove-global-assumption "RealLeCrit")

; For the proof we can use

(add-global-assumption
 "RealLeChar1"
 (pf "all x,y.Real x -> Real y ->
              (all k ex n0 all n.n0<=n -> (1#exp 2 k)<=y seq n-x seq n) ->
              x<<=y"))

; (remove-global-assumption "RealLeChar1")

(add-global-assumption
 "CauchyEstPlus"
 (pf "all as,M.Cauchy as M ->
               all k,n,m.M k<=n -> M k<=m ->
                         as n<=as m+(1#exp 2 k)"))

(add-global-assumption
 "CauchyEstMinus"
 (pf "all as,M.Cauchy as M ->
               all k,n,m.M k<=n -> M k<=m ->
                         as n-(1#exp 2 k)<=as m"))

(add-global-assumption
 "RatMinusLe2"
 (pf "all a1,a2,b1,b2.a1<=a2 -> b2<=b1 -> a1-b1<=a2-b2"))

(add-global-assumption "RatLeLin" (pf "all a,b.(a<=b -> F) -> b<=a"))


(add-var-name "L" (py "pos=>pos"))

; We now prove "ApproxSplit", the Approximate Splitting Principle.

; (set-goal (pf "all x,y,z,k.Real x -> Real y -> Real z ->
;                            RealLt x y k -> ex boole.
;                            (boole -> z<<=y) & ((boole -> F) -> x<<=z)"))
; (ind)
; (assume "as" "M")
; (ind)
; (assume "bs" "N")
; (ind)
; (assume "cs" "L")
; (assume "k" "Real x" "Real y" "Real z" "x<y")

; ; We introduce a definition M(k+2)max N(k+2)=p
; (cut (pf "all p.M(k+2)max N(k+2)=p -> ex boole.
;            (boole -> RealConstr cs L<<=RealConstr bs N) & 
;            ((boole -> F) -> RealConstr as M<<=RealConstr cs L)"))
; (assume "pImp")
; (use "pImp" (pt "M(k+2)max N(k+2)"))
; (use "Truth-Axiom")
; (assume "p" "p-Def")

; ; We introduce a definition (bs p-as p)/4=d
; (cut (pf "all d.(bs p-as p)/4=d -> ex boole.
;            (boole -> RealConstr cs L<<=RealConstr bs N) & 
;            ((boole -> F) -> RealConstr as M<<=RealConstr cs L)"))
; (assume "dImp")
; (use "dImp" (pt "(bs p-as p)/4"))
; (auto)
; (assume "d" "d-Def")

; (ex-intro (pt "cs(p max L(k+2))<=as p+2*d"))
; (split)

; ; Case cs(p max L(k+2))<=as p+2*d
; (assume "CaseHyp")
; (use "RealLeCrit" (pt "p max L(k+2)"))
; (auto)
; (assume "n" "p max L(k+2)<=n")
; (cut (pf "RealLt(RealConstr as M)(RealConstr bs N)k"))
; (drop "x<y")
; (ng)
; (simp "p-Def")
; (assume "Hyp") ;x<y

; ; ?_42: cs n<=bs n
; (use "RatLeTrans" (pt "cs(p max L(k+2))+(1#exp 2(k+2))"))

; ; ?_34: cs n<=cs(p max L(k+2))+(1#exp 2(k+2))
; (use "CauchyEstPlus" (pt "L"))
; (auto 1 '("RealElimVariant1" 1))
; (use "PosLeTrans" (pt "p max L(S(S k))"))
; (use "PosMaxUB2")
; (use "p max L(k+2)<=n")
; (use "PosMaxUB2")

; ; ?_35: cs(p max L(k+2))+(1#exp 2(k+2))<=bs n
; (cut (pf "(1#exp 2(k+2))<=(bs p-as p)/4"))
; (simp "d-Def")
; (assume "d-Est")
; (use "RatLeTrans" (pt "as p+2*d+d"))
; (use "RatPlusLe2")
; (auto)

; ; ?_46: as p+2*d+d<=bs n
; (use "RatEqLe" (pt "bs p-d"))

; ; ?_49: as p+2*d+d==bs p-d
; (cut (pf "d=(bs p-as p)/4"))
; (assume "d-Def-Rev")
; (simp "d-Def-Rev")
; (ord-field-simp-bwd)
; (use "Truth-Axiom")
; (simp "d-Def")
; (use "Truth-Axiom")

; ; ?_50: bs p-d<=bs n
; (use "RatLeTrans" (pt "bs p-(1#exp 2(k+2))"))

; ; ?_57: bs p-d<=bs p-(1#exp 2(k+2))
; (use "RatMinusLe2")
; (auto)

; ; ?_58: bs p-(1#exp 2(k+2))<=bs n
; (use "CauchyEstMinus" (pt "N"))
; (auto 1 '("RealElimVariant1" 1))
; (cut (pf "N(k+2)<=M(S(S k))max N(S(S k))"))
; (simp "p-Def")
; (prop)
; (use "PosMaxUB2")
; (use "PosLeTrans" (pt "M(S(S k))max N(S(S k))"))
; (use "PosMaxUB2")
; (simp "p-Def")
; (use "PosLeTrans" (pt "p max L(S(S k))"))
; (use "PosMaxUB1")
; (use "p max L(k+2)<=n")

; ; ?_42: (1#exp 2(k+2))<=(bs p-as p)/4
; (ord-field-simp-fwd "Hyp")
; (ord-field-simp-bwd)
; (auto) ;done again in the 2nd case, to be done befor the case distinction

; ;?_22: (cs(p max L(k+2))<=as p+2*d -> F) -> RealConstr as M<<=RealConstr cs L
; (assume "CaseHyp")
; (use "RealLeCrit" (pt "p max L(k+2)"))
; (auto)
; (assume "n" "p max L(k+2)<=n")
; (cut (pf "RealLt(RealConstr as M)(RealConstr bs N)k"))
; (drop "x<y")
; (ng)
; (simp "p-Def")
; (assume "Hyp") ;x<y

; ; ?_85: as n<=cs n
; (use "RatLeTrans" (pt "as p+(1#exp 2(k+2))"))

; ; ?_86: as n<=as p+(1#exp 2(k+2))
; (use "CauchyEstPlus" (pt "M"))
; (auto 1 '("RealElimVariant1" 1))
; (use "PosLeTrans" (pt "p max L(S(S k))"))
; (use "PosLeTrans" (pt "M(S(S k))max N(S(S k))"))
; (use "PosMaxUB1")
; (simp "p-Def")
; (use "PosMaxUB1")
; (use "p max L(k+2)<=n")
; (use "PosLeTrans" (pt "M(S(S k))max N(S(S k))"))
; (use "PosMaxUB1")
; (simp "p-Def")
; (use "Truth-Axiom")

; ; ?_87: as p+(1#exp 2(k+2))<=cs n
; (cut (pf "(1#exp 2(k+2))<=(bs p-as p)/4"))
; (simp "d-Def")
; (assume "d-Est")
; (use "RatLeTrans" (pt "as p+d"))
; (use "RatPlusLe2")
; (auto)

; ; ?_104: as p+d<=cs n
; (use "RatEqLe" (pt "as p+2*d-d"))
; (ord-field-simp-bwd)

; ; ?_108: as p+2*d-d<=cs n
; (cut (pf "as p+2*d<=cs(p max L(k+2))"))
; (assume "CaseHypEquiv")
; (use "RatLeTrans" (pt "cs(p max L(k+2))-(1#exp 2(k+2))"))
; (use "RatMinusLe2")

; ; ?_114: as p+2*d<=cs(p max L(k+2))
; (use "RatLeLin")
; (auto)

; ; ?_113: cs(p max L(k+2))-(1#exp 2(k+2))<=cs n
; (use "CauchyEstMinus" (pt "L"))
; (auto 1 '("RealElimVariant1" 1))
; (use "PosMaxUB2")
; (use "PosLeTrans" (pt "p max L(k+2)"))
; (use "PosMaxUB2")
; (use "p max L(k+2)<=n")

; ; ?_110: as p+2*d<=cs(p max L(k+2))
; (use "RatLeLin")
; (auto)

; ; ?_100: (1#exp 2(k+2))<=(bs p-as p)/4
; (ord-field-simp-fwd "Hyp")
; (ord-field-simp-bwd)
; (auto)

; 04-09-01 This proof suffers from the use of the case distinction c_q
; <= a_p + 2*d.  The extracted terms will be better if we use the
; equivalent c_q <= (a_p + b_p)/2 instead.

; "ApproxSplit"
(set-goal (pf "all x,y,z,k.Real x -> Real y -> Real z ->
                           RealLt x y k -> ex boole.
                           (boole -> z<<=y) & ((boole -> F) -> x<<=z)"))
(ind)
(assume "as" "M")
(ind)
(assume "bs" "N")
(ind)
(assume "cs" "L")
(assume "k" "Real x" "Real y" "Real z" "x<y")

; We introduce a definition M(k+2)max N(k+2)=p
(cut (pf "all p.M(k+2)max N(k+2)=p -> ex boole.
           (boole -> RealConstr cs L<<=RealConstr bs N) & 
           ((boole -> F) -> RealConstr as M<<=RealConstr cs L)"))
(assume "pImp")
(use "pImp" (pt "M(k+2)max N(k+2)"))
(use "Truth-Axiom")
(assume "p" "p-Def")

(ex-intro (pt "cs(p max L(k+2))<=(as p+bs p)/2"))
(split)

; Case cs(p max L(k+2))<=(as p+bs p)/2
(assume "CaseHyp")
(use "RealLeCrit" (pt "p max L(k+2)"))
(auto)
(assume "n" "p max L(k+2)<=n")
(cut (pf "RealLt(RealConstr as M)(RealConstr bs N)k"))
(drop "x<y")
(ng)
(simp "p-Def")
(assume "Hyp") ;x<y
(cut (pf "(1#exp 2(k+2))<=(bs p-as p)/4"))
(assume "Hyp/4")

; ?_30: cs n<=bs n
(use "RatLeTrans" (pt "cs(p max L(k+2))+(1#exp 2(k+2))"))

; ?_31: cs n<=cs(p max L(k+2))+(1#exp 2(k+2))
(use "CauchyEstPlus" (pt "L"))
(auto 1 '("RealElimVariant1" 1))
(use "PosLeTrans" (pt "p max L(S(S k))"))
(use "PosMaxUB2")
(use "p max L(k+2)<=n")
(use "PosMaxUB2")

; ?_32: cs(p max L(k+2))+(1#exp 2(k+2))<=bs n
(use "RatLeTrans" (pt "(as p+bs p)/2 + (bs p-as p)/4"))

; ?_38: cs(p max L(k+2))+(1#exp 2(k+2))<=(as p+bs p)/2+(bs p-as p)/4
(use "RatPlusLe2")
(use "CaseHyp")
(use "Hyp/4")

; ?_39: (as p+bs p)/2+(bs p-as p)/4<=bs n
(use "RatEqLe" (pt "bs p-(bs p-as p)/4"))

; ?_42: (as p+bs p)/2+(bs p-as p)/4<=bs p-(bs p-as p)/4
(ord-field-simp-bwd)
(auto)

; ?_43: bs p-(bs p-as p)/4<=bs n
(use "RatLeTrans" (pt "bs p-(1#exp 2(k+2))"))

; ?_46: bs p-(bs p-as p)/4<=bs p-(1#exp 2(k+2))
(use "RatMinusLe2")
(use "Truth-Axiom")
(use "Hyp/4")

; ?_47: bs p-(1#exp 2(k+2))<=bs n
(use "CauchyEstMinus" (pt "N"))
(auto 1 '("RealElimVariant1" 1))
(cut (pf "N(k+2)<=M(S(S k))max N(S(S k))"))
(simp "p-Def")
(prop)
(use "PosMaxUB2")
(use "PosLeTrans" (pt "M(S(S k))max N(S(S k))"))
(use "PosMaxUB2")
(simp "p-Def")
(use "PosLeTrans" (pt "p max L(S(S k))"))
(use "PosMaxUB1")
(use "p max L(k+2)<=n")

; ?_29: (1#exp 2(k+2))<=(bs p-as p)/4
(use "RatEqLe" (pt "(1#exp 2 k)/4"))
(add-global-assumption
 "ApproxSplitAux1" (pf "all k (1#exp 2(k+2))==(1#exp 2 k)/4"))
(use "ApproxSplitAux1")
(add-global-assumption
 "RatDivLe" (pf "all a,b,c,d.a<=b -> 0<d -> d<=c -> a/c<=b/d"))
(use "RatDivLe")
(use "Hyp")
(use "Truth-Axiom")
(use "Truth-Axiom")

; ?_23: RealLt(RealConstr as M)(RealConstr bs N)
(use "x<y")

; ?_16: (cs(p max L(k+2))<=(as p+bs p)/2 -> F) -> RealConstr as M<<=RealConstr cs L
(assume "CaseHyp")
(use "RealLeCrit" (pt "p max L(k+2)"))
(auto)
(assume "n" "p max L(k+2)<=n")
(cut (pf "RealLt(RealConstr as M)(RealConstr bs N)k"))
(drop "x<y")
(ng)
(simp "p-Def")
(assume "Hyp") ;x<y
(cut (pf "(1#exp 2(k+2))<=(bs p-as p)/4"))
(assume "Hyp/4")

; ?_79: as n<=cs n
(use "RatLeTrans" (pt "as p+(1#exp 2(k+2))"))

; ?_79: as n<=as p+(1#exp 2(k+2))
(use "CauchyEstPlus" (pt "M"))
(auto 1 '("RealElimVariant1" 1))
(use "PosLeTrans" (pt "p max L(S(S k))"))
(use "PosLeTrans" (pt "M(S(S k))max N(S(S k))"))
(use "PosMaxUB1")
(simp "p-Def")
(use "PosMaxUB1")
(use "p max L(k+2)<=n")
(use "PosLeTrans" (pt "M(S(S k))max N(S(S k))"))
(use "PosMaxUB1")
(simp "p-Def")
(use "Truth-Axiom")

; ?_81: as p+(1#exp 2(k+2))<=cs n
(use "RatLeTrans" (pt "as p+(bs p-as p)/4"))

; ?_93: as p+(1#exp 2(k+2))<=as p+(bs p-as p)/4
(use "RatPlusLe2")
(use "Truth-Axiom")
(use "Hyp/4")

; ?_94: as p+(bs p-as p)/4<=cs n
(use "RatEqLe" (pt "(as p+bs p)/2-(bs p-as p)/4"))

; ?_97: as p+(bs p-as p)/4==(as p+bs p)/2-(bs p-as p)/4
(ord-field-simp-bwd)
(auto)

; ?_98: (as p+bs p)/2-(bs p-as p)/4<=cs n
(use "RatLeTrans" (pt "cs(p max L(k+2))-(1#exp 2(k+2))"))

; ?_101: (as p+bs p)/2-(bs p-as p)/4<=cs(p max L(k+2))-(1#exp 2(k+2))
(use "RatMinusLe2")
(use "RatLeLin")
(use "CaseHyp")
(use "Hyp/4")

; ?_102: cs(p max L(k+2))-(1#exp 2(k+2))<=cs n
(use "CauchyEstMinus" (pt "L"))
(auto 1 '("RealElimVariant1" 1))
(use "PosMaxUB2")
(use "PosLeTrans" (pt "p max L(k+2)"))
(use "PosMaxUB2")
(use "p max L(k+2)<=n")

; ?_78: (1#exp 2(k+2))<=(bs p-as p)/4
(use "RatEqLe" (pt "(1#exp 2 k)/4"))
(use "ApproxSplitAux1")
(use "RatDivLe")
(use "Hyp")
(use "Truth-Axiom")
(use "Truth-Axiom")

; ?_72: RealLt(RealConstr as M)(RealConstr bs N)k
(use "x<y")

(save "ApproxSplit")

(define ApproxSplit-eterm
  (proof-to-extracted-term (theorem-name-to-proof "ApproxSplit")))
(define ApproxSplit-neterm (nt ApproxSplit-eterm))

(pp ApproxSplit-neterm)

"(Rec real=>real=>real=>pos=>boole)
([as4,M5]
  (Rec real=>real=>pos=>boole)
  ([as9,M10]
    (Rec real=>pos=>boole)
    ([as13,M14,n15]
      as13(M5(S(S n15))max M10(S(S n15))max M14(S(S n15)))<=
      (as4(M5(S(S n15))max M10(S(S n15)))+as9(M5(S(S n15))max M10(S(S n15))))/
      2)))"
; Was

"(Rec real=>real=>real=>pos=>boole)
 ([as4,M5]
  (Rec real=>real=>pos=>boole)
   ([as9,M10]
    (Rec real=>pos=>boole)
     ([as13,M14,n15]
      as13
       (M5(S(S n15))max M10(S(S n15))max
         M14(S(S n15)))<=
       as4(M5(S(S n15))max M10(S(S n15)))+
        2*
         ((as9(M5(S(S n15))max M10(S(S n15)))-
          as4(M5(S(S n15))max M10(S(S n15))))/4))))"


; Intermediate value theorem, with 1/2^l a lower bound on the slope:

; We first prove an auxiliary lemma IVTAux, for the construction step.

; First we define a (formally inductive) correctness predicate:

(add-ids
 (list (list "Corr" (make-arity (py "cont") (py "rat") (py "rat") (py "pos"))))
 '("all f,c,d,n.
     f doml<=c -> d<=f domr -> (1#exp 2 n)<=d-c ->
     f c<<=0 -> 0<<=f d ->
     Corr f c d n" "CorrIntro"))

; (formula-to-string (pf "Corr f c d n"))

; Now the properties of Corr.

; (set-goal
;  (pf "all f,c,d,n.
;       f doml<=c -> d<=f domr -> (1#exp 2 n)<=d-c ->
;       f c<<=0 -> 0<<=f d ->
;       Corr f c d n"))
; (strip)
; (intro 0)            
; (auto 1)
; (save "CorrIntro")

(set-goal (pf "all f,c,d,n.Corr f c d n -> f doml<=c"))
(assume "f" "c" "d" "n")
(elim)
(search)
(save "CorrElim1")

(set-goal (pf "all f,c,d,n.Corr f c d n -> d<=f domr"))
(assume "f" "c" "d" "n")
(elim)
(search)
(save "CorrElim2")

(set-goal (pf "all f,c,d,n.Corr f c d n -> (1#exp 2 n)<=d-c"))
(assume "f" "c" "d" "n")
(elim)
(search)
(save "CorrElim3")

(set-goal (pf "all f,c,d,n.Corr f c d n -> f c<<=0"))
(assume "f" "c" "d" "n")
(elim)
(search)
(save "CorrElim4")

(set-goal (pf "all f,c,d,n.Corr f c d n -> 0<<=f d"))
(assume "f" "c" "d" "n")
(elim)
(search)
(save "CorrElim5")

; To unclutter the proof of IVTAux, we first prove two easy lemmata
; concerning correctness.  First IVTAux1:

; "IVTAux1"
(set-goal
 (pf "all f,c,d,n.Cont f -> Corr f c d n -> 0<<=f((1#3)*c+(2#3)*d) ->
                  Corr f c((1#3)*c+(2#3)*d)(S n)"))
(assume "f" "c" "d" "n" "Cont f" "Corr f c d n" "0<<=f d1")
(cut (pf "f doml<=c"))
(assume "a<=c")
(cut (pf "d<=f domr"))
(assume "d<=b")
(cut (pf "(1#exp 2 n)<=d-c"))
(assume "c<_n d")
(cut (pf "f c<<=0"))
(assume "f c<<=0")
(cut (pf "0<<=f d"))
(assume "0<<=f d")

; ?_17: Corr f c((1#3)*c+(2#3)*d)(S n)
(use "CorrIntro")
(auto)

; ?_19: (1#3)*c+(2#3)*d<=f domr
(use "RatLeTrans" (pt "d"))

; ?_23: (1#3)*c+(2#3)*d<=d
(ord-field-simp-bwd)

; ?_25: c<=d
(use "RatLeAux1")
(use "RatLeTrans" (pt "IntP 1#exp 2 n"))
(auto)

; ?_20: (1#exp 2(S n))<=(1#3)*c+(2#3)*d-c 
(add-global-assumption "RatLeTimes" (pf "all a,b,c.0<=a -> b<=c -> a*b<=a*c"))
(add-global-assumption
 "RatLeTimes2" (pf "all a,b,c,d.0<=a -> a<=b -> 0<=c -> c<=d -> a*c<=b*d"))
(use "RatEqLe" (pt "(1#2)*(1#exp 2 n)"))
(add-global-assumption
 "PosExpTwoSuc" (pf "all n SZero(exp 2 n)=exp 2(S n)"))
(use "PosExpTwoSuc")

; ?_31: (1#2)*(1#exp 2 n)<=(1#3)*c+(2#3)*d-c
(use "RatLeEq" (pt "(2#3)*(d-c)"))
(use "RatLeTimes2")
(auto)

; ?_33: (2#3)*(d-c)==(1#3)*c+(2#3)*d-c
(ord-field-simp-bwd)

; ?_21: f c<<=0
(use-with "CorrElim4" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")
(auto)

; ?_16: 0<<=f d
(use-with "CorrElim5" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")

; ?_13: f c<<=0
(use-with "CorrElim4" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")

(use-with "CorrElim3" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")
(use-with "CorrElim2" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")
(use-with "CorrElim1" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")

(save "IVTAux1")


; "IVTAux2"
(set-goal
 (pf "all f,c,d,n.Cont f -> Corr f c d n -> f((2#3)*c+(1#3)*d)<<=0 ->
                  Corr f((2#3)*c+(1#3)*d)d(S n)"))
(assume "f" "c" "d" "n" "Cont f" "Corr f c d n" "f c1<<=0")
(cut (pf "f doml<=c"))
(assume "a<=c")
(cut (pf "d<=f domr"))
(assume "d<=b")
(cut (pf "(1#exp 2 n)<=d-c"))
(assume "c<_n d")
(cut (pf "f c<<=0"))
(assume "f c<<=0")
(cut (pf "0<<=f d"))
(assume "0<<=f d")

; ?_17: Corr f((2#3)*c+(1#3)*d)d(S n)
(use "CorrIntro")

; ?_18: f doml<=(2#3)*c+(1#3)*d
(use "RatLeTrans" (pt "c"))
(auto)

; ?_24: c<=(2#3)*c+(1#3)*d
(ord-field-simp-bwd)

; ?_25: c<=d
(use "RatLeAux1")
(use "RatLeTrans" (pt "IntP 1#exp 2 n"))
(auto)

; ?_20: (1#exp 2(S n))<=d-((2#3)*c+(1#3)*d)
(add-global-assumption "RatLeTimes" (pf "all a,b,c.0<=a -> b<=c -> a*b<=a*c"))
(add-global-assumption
 "RatLeTimes2" (pf "all a,b,c,d.0<=a -> a<=b -> 0<=c -> c<=d -> a*c<=b*d"))
(use "RatEqLe" (pt "(1#2)*(1#exp 2 n)"))
(add-global-assumption "PosExpTwoSuc" (pf "all n SZero(exp 2 n)=exp 2(S n)"))
(use "PosExpTwoSuc")

; ?_30: (1#2)*(1#exp 2 n)<=d-((2#3)*c+(1#3)*d)
(use "RatLeEq" (pt "(2#3)*(d-c)"))
(use "RatLeTimes2")
(auto)

; ?_32: (2#3)*(d-c)==d-((2#3)*c+(1#3)*d)
(ord-field-simp-bwd)
(auto)

; ?_22: 0<<=f d
(use-with "CorrElim5" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")

; ?_13: f c<<=0
(use-with "CorrElim4" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")

(use-with "CorrElim3" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")
(use-with "CorrElim2" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")
(use-with "CorrElim1" (pt "f") (pt "c") (pt "d") (pt "n") "Corr f c d n")

(save "IVTAux2")


; Now we prove IVTAux

(add-var-name "cd" (make-star (py "rat") (py "rat")))

; (formula-to-string (pf "Corr f(left cd)(right cd)n"))

; We introduce let (for cd0) in the proof, for effiency of evaluation


; Avoiding Duplication of Terms: Local Variables
; ============================================== 

; To avoid that a term is duplicated by normalization, we block beta
; conversion by a form of the let construct, but at the proof level.

(set-goal (pf "(Pvar^1 -> Pvar^2) -> Pvar^1 -> Pvar^2"))
(assume 1 2)
(use-with 1 2)
(save "Ap")

; We may then animate cAp if desired.  

(animate "Ap")
; ok, computation rule 
; (cAp alpha33 alpha34) -> [(alpha33=>alpha34)_0](alpha33=>alpha34)_0 added
(deanimate "Ap")

; Usage: Given a goal and a formula B to be cut in, instead of (cut B)
; do (use-with "Ap" (make-cterm B) "?" "?").  In the extracted term we
; then have cAp([valB]r)[[M_B]] (like: let valB=[[M_B]] in r), which
; can be normalized without duplicating [[M_B]].  Also, when finally a
; numerical result is to be computed, we can animate Ap and still compute
; [[M_B]] only once.

; Similarly we deal with universal quantifiers instead of implication:

; "AllElim"
; (set-goal (pf "all alpha (Pvar alpha)^alpha -> all alpha (Pvar alpha)^alpha"))
; (search)
; (save "AllElim")

; (animate "AllElim")
; ; ok, computation rule 
; ; (cAllElim alpha alpha121) -> [(alpha=>alpha121)_0](alpha=>alpha121)_0 added
; (deanimate "AllElim")

; Usage: We are given a goal all x G(x), which might later be applied
; to a hard to compute term r.

; More generally, for both implications and universal quantifiers

"Id"
(set-goal (pf "Pvar^ -> Pvar^"))
(assume 1)
(use 1)
(save "Id")

(animate "Id")
; ok, computation rule (cId alpha3) -> [(alpha3)_0](alpha3)_0 added
(deanimate "Id")

; Usage: When an object (value of a variable or realizer of a premise)
; might be used more than once, make sure (if necessary by a cut) that
; the goal has the form A -> B or all x A.  Now use Id: P -> P.  Its
; realizer then has the form [f,x]f x.  If cId is not animated, one
; obtains cId([x]body)arg, to be written [let x arg body].

"IVTAux"
(set-goal
 (pf "all f,l.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->
     all n,cd.Corr f(left cd)(right cd)n ->
      ex cd1.Corr f(left cd1)(right cd1)(S n) & 
             (left cd<=left cd1 & right cd1<=right cd &
             right cd1-left cd1=(2#3)*(right cd-left cd))"))
(assume "f" "l" "Cont f" "f a<<=0" "0<<=f b" "HypSlope" "n")
(use "Id")
(assume "cd" "Corr f c d n")
(cut (pf "f doml<=left cd"))
(assume "a<=c")
(cut (pf "right cd<=f domr"))
(assume "d<=b")
(cut (pf "left cd<=right cd"))
(assume "c<=d")

(cut (pf "ex cd0.left cd0=(2#3)*left cd+(1#3)*right cd &
                 right cd0=(1#3)*left cd+(2#3)*right cd"))
(use "Id")
(assume "ExHyp")
(by-assume-with "ExHyp" "cd0" "cd0-Def")
(inst-with-to "cd0-Def" 'left "c0-Def")
(inst-with-to "cd0-Def" 'right "d0-Def")
(drop "cd0-Def")

(cut
 (pf "ex boole.(boole -> 0<<=f(right cd0)) &
               ((boole -> F) -> f(left cd0)<<=0)"))
(assume "ExBooleHyp")
(by-assume-with "ExBooleHyp" "boole" "ExKernel")
(cases (pt "boole"))

; Case 1
(assume "Left")
(cut (pf "0<<=f(right cd0)"))
(assume "0<<=f d0")
(ex-intro (pt "left cd@right cd0"))
(split)
(ng)

; ?_38: Corr f(left cd)(right cd0)(S n)
(simp "d0-Def")
(use "IVTAux1")
(auto)
(cut (pf "0<<=RealConstr(f approx right cd0)([n1]f uMod(S(S n1)))"))
(simp "d0-Def")
(ng)
(prop)
(use "0<<=f d0")

(split)
(split)
(use "Truth-Axiom")

; ?_50: right(left cd@right cd0)<=right cd
(ng)
(simp "d0-Def")
(ord-field-simp-bwd)
(use "c<=d")

; ?_48: right(left cd@right cd0)-left(left cd@right cd0)=(2#3)*(right cd-left cd)
(ng)
(simp "d0-Def")
(ord-field-simp-bwd)
(search)

; Case 2
(assume "Right")
(cut (pf "f(left cd0)<<=0"))
(assume "f c0<<=0")
(ex-intro (pt "left cd0@right cd"))
(split)
(ng)

; ?_62: Corr f(left cd0)(right cd)(S n)
(simp "c0-Def")
(use "IVTAux2")
(auto)
(cut (pf "RealConstr(f approx left cd0)([n1]f uMod(S(S n1)))<<=0"))
(simp "c0-Def")
(ng)
(prop)
(use "f c0<<=0")

(split)
(split)

; ?_73: left cd<=left(left cd0@right cd)
(ng)
(simp "c0-Def")
(ord-field-simp-bwd)
(auto)

; ?_72: right(left cd0@right cd)-left(left cd0@right cd)=(2#3)*(right cd-left cd)
(ng)
(simp "c0-Def")
(ord-field-simp-bwd)
(auto)

; ?_24: ex boole.(boole -> 0<<=f(right cd0)) & ((boole -> F) -> f(left cd0)<<=0)
(cut (pf "f doml<=left cd0"))
(assume "a<=c0")
(cut (pf "left cd0<=f domr"))
(assume "c0<=b")
(cut (pf "f doml<=right cd0"))
(assume "a<=d0")
(cut (pf "right cd0<=f domr"))
(assume "d0<=b")

(use "ApproxSplit" (pt "n+2+l"))

; ?_92: Real(f(left cd0))
(add-global-assumption
 "ContValsReal"
 (pf "all f,x.Cont f -> Real x -> f doml<<=x -> x<<=f domr -> Real(f x)"))
(add-global-assumption
 "ContRatValsReal"
 (pf "all f,c.Cont f -> f doml<=c -> c<=f domr -> Real(f c)"))
(use "ContRatValsReal")
(auto)

; ?_93: Real(f(right cd0))
(use "ContRatValsReal")
(auto)

; ?_68: Real(0)
(add-global-assumption "RatReal" (pf "all a.Real a"))
(use "RatReal")

; ?_95: RealLt(f(left cd0))(f(right cd0))(n+2+l)
(use "HypSlope")
(auto)

; ?_104: (1#exp 2(n+2))<=right cd0-(left cd0)
(use "RatLeTrans" (pt "(right cd-left cd)*(1#exp 2 2)"))

; ?_79: (1#exp 2(n+2))<=(right cd-left cd)*(1#exp 2 2)
(add-global-assumption
 "IvtAuxAux2"
 (pf "all n,a.(1#exp 2 n)<=a -> (1#exp 2(n+2))<=a*(1#exp 2 2)"))
(use "IvtAuxAux2")
(use "CorrElim3" (pt "f"))
(use "Corr f c d n")

; ?_107: (right cd-left cd)*(1#exp 2 2)<=right cd0-left cd0
(simp "c0-Def")
(simp "d0-Def")
(ord-field-simp-bwd)
(auto)

; Now we need to prove the 4 estimates cut in earlier.

; ?_90: right cd0<=f domr
(use "RatLeTrans" (pt "right cd"))

; ?_112: right cd0<=right cd
(simp "d0-Def")
(ord-field-simp-bwd)
(auto)

; ?_87: f doml<=right cd0
(simp "d0-Def")
(use "RatLeTrans" (pt "left cd"))
(auto)

; ?_118: left cd<=(1#3)*left cd+(2#3)*right cd
(ord-field-simp-bwd)
(use "c<=d")

; ?_84: left cd0<=f domr
(use "RatLeTrans" (pt "right cd"))

; ?_120: left cd0<=right cd
(simp "c0-Def")
(ord-field-simp-bwd)
(auto)

; ?_81: f doml<=left cd0
(use "RatLeTrans" (pt "left cd"))
(auto)

; ?_125: left cd<=left cd0
(simp "c0-Def")
(ord-field-simp-bwd)
(use "c<=d")

; ?_13: ex cd0.left cd0=(2#3)*left cd+(1#3)*right cd & right cd0=(1#3)*left cd+(2#3)*right cd
(ex-intro (pt "((2#3)*left cd+(1#3)*right cd)@((1#3)*left cd+(2#3)*right cd)"))
(prop)

; ?_10: left cd<=right cd
(use "RatLeAux1")
(use "RatLeTrans" (pt "IntP 1#exp 2 n"))
(auto)
(use-with "CorrElim3" (pt "f") (pt "left cd") (pt "right cd") (pt "n") "Corr f c d n")

; ?_7: right cd<=f domr
(use-with "CorrElim2" (pt "f") (pt "left cd") (pt "right cd") (pt "n") "Corr f c d n")

; ?_4: f doml<=left cd
(use-with "CorrElim1" (pt "f") (pt "left cd") (pt "right cd") (pt "n") "Corr f c d n")

(save "IVTAux")

(define IVTAux-eterm
  (proof-to-extracted-term (theorem-name-to-proof "IVTAux")))
(define IVTAux-neterm (nt IVTAux-eterm))

(pp IVTAux-neterm)
(type-to-string (term-to-type IVTAux-neterm))

"[f0,n1,n2]
 (cId rat@@rat=>rat@@rat)
 ([cd4]
   [let cd5
     ((2#3)*left cd4+(1#3)*right cd4@(1#3)*left cd4+(2#3)*right cd4)
     [if (cApproxSplit(RealConstr(f0 approx left cd5)([n6]f0 uMod(S(S n6))))
          (RealConstr(f0 approx right cd5)([n6]f0 uMod(S(S n6))))
          0
          (S(S(n2+n1))))
      (left cd4@right cd5)
      (left cd5@right cd4)]])"

; Concrete computations:

(pp (nt (pt "(Rec pos=>rat@@rat)
          ((ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))doml@
           (ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))domr)
          ([n,cd]cIVTAux(ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))1 n cd)
          ([n,cd]cIVTAux(ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))1 n cd)
          2")))

"cIVTAux(ContConstr 1 2([a0,n1]a0*a0-2)([n0]1)S)1 1(1@2)"

(animate "IVTAux")
(animate "ApproxSplit")

; (term-to-string (nt (pt "(cApproxSplit(IntN 2#9)(7#9)0 3)")))
; => "True"
; (term-to-string (nt (pt "(cApproxSplit(IntN 41#81)(7#81)0 4)")))
; => "False"

(animate "Id")

(pp (nt (pt "(Rec pos=>rat@@rat)
          ((ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))doml@
           (ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))domr)
          ([n,cd]cIVTAux(ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))1 n cd)
          ([n,cd]cIVTAux(ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))1 n cd)
          2")))
; 1@15#9
; Was
; "1@5#3"

(pp (nt (pt "(Rec pos=>rat@@rat)
          ((ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))doml@
           (ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))domr)
          ([n,cd]cIVTAux(ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))1 n cd)
          ([n,cd]cIVTAux(ContConstr 1 2([a,n]a*a-2)([k]1)([k]k+1))1 n cd)
          10")))

; (99#81)@9963#6561
; Was
; "(11#9)@1107#729"

(deanimate "Id")
(deanimate "ApproxSplit")
(deanimate "IVTAux")


; We now want prove the existence of the sequence of cds.

; It seems most direct to make use of the (valid) axiom of dependent choice:

(add-var-name "xx" "yy" (py "alpha"))
(add-var-name "xxs" (py "pos=>alpha"))
(add-pvar-name "RR" (make-arity (py "pos") (py "alpha")))
(add-pvar-name "SS" (make-arity (py "pos") (py "alpha") (py "alpha")))

; (remove-pvar-name "RR")
; (remove-pvar-name "SS")

; For the moment we add DC as a global assumption, animated by the
; appropriate recursion operator.  Later, it should be added as an
; axiom.  For simplicity we choose a formulation of DC using a
; predicate variable without computational content.

(add-global-assumption
 "DC"
 (pf "all xx0.RR 1 xx0 -> 
      (all n,xx.RR n xx -> ex yy.RR(S n)yy & SS n xx yy) -> 
      ex xxs.Equal(xxs 1)xx0 & 
             all n RR n(xxs n) & all n SS n(xxs n)(xxs(S n))")
 3)

; (remove-global-assumption "DC")

(define et-type (formula-to-et-type
		 (aconst-to-uninst-formula
		  (global-assumption-name-to-aconst "DC"))))

(type-to-string et-type) ;"alpha=>(pos=>alpha=>alpha)=>pos=>alpha"

(add-var-name "init" (py "alpha"))
(add-var-name "step" (py "pos=>alpha=>alpha"))

(add-computation-rule (pt "(cDC alpha) init step 1") (pt "init"))
(add-computation-rule
 (pt "(cDC alpha) init step(SZero n)")
 (pt "step(SZero n)((cDC alpha) init step(PosPred(SZero n)))"))
(add-computation-rule
 (pt "(cDC alpha) init step(SOne n)")
 (pt "step(SOne n)((cDC alpha) init step(PosPred(SOne n)))"))

(display-program-constants "cDC")

(add-var-name "cds" (py "pos=>rat@@rat"))

; "IVTcds"
(set-goal 
 (pf "all f,l,k0.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (1#exp 2(k0+1))<=f domr-f doml ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->     
     ex cds.Equal(cds 1)(f doml@f domr) &
            all n Corr f(left(cds n))(right(cds n))(k0+n) &
            all n.left(cds n)<=left(cds(S n)) & 
                  right(cds(S n))<=right(cds n) &
                  right(cds(S n))-left(cds(S n))=
                  (2#3)*(right(cds n)-left(cds n))"))
(assume "f" "l" "k0" "Cont f" "f a<<=0" "0<<=f b" "a <_k0 b" "HypSlope")

; ?_2: ex cds.Equal(cds 1)(f doml@f domr) & all n Corr f(left(cds n))(right(cds n))(k0+n) & (all n.left(cds n)<=left(cds(S n)) & right(cds(S n))<=right(cds n) & right(cds(S n))-left(cds(S n))=(2#3)*(right(cds n)-left(cds n)))
(cut
 (pf "ex cds.Equal(cds 1)(f doml@f domr) &
             all n Corr f(left(cds n))(right(cds n))(k0+n) &
             all n.left(cds n)<=left(cds(S n)) & 
                   right(cds(S n))<=right(cds n) &
                   right(cds(S n))-left(cds(S n))=
                   (2#3)*(right(cds n)-left(cds n))"))
(assume "DCInst")
(by-assume-with "DCInst" "cds" "H")
(ex-intro (pt "cds"))
(search)

; Now we prove the cut formula by instantiating DC
(use-with
 "DC"
 (py "rat@@rat")
 (make-cterm (pv "n") (pv "cd") (pf "Corr f(left cd)(right cd)(k0+n)"))
 (make-cterm (pv "n") (pv "cd") (pv "cd1")
	     (pf "left cd<=left cd1 & right cd1<=right cd &
                  right cd1-left cd1=(2#3)*(right cd-left cd)"))
 (pt "f doml@f domr") "?" "?")

; ?_10: Corr f(left(f doml@f domr))(right(f doml@f domr))(k0+1)
(use "CorrIntro")
(auto)

; Now the step hypothesis, to be proved by means of IVTAux
(assume "n" "cd" "Corr-Hyp")

; ?_17: ex cd1973.Corr f(left cd1973)(right cd1973)(k0+S n) & (left cd<=left cd1973 & right cd1973<=right cd & right cd1973-left cd1973=(2#3)*(right cd-left cd))
(use "IVTAux" (pt "l"))
(auto)

(save "IVTcds")

(define IVTcds-eterm
  (proof-to-extracted-term (theorem-name-to-proof "IVTcds")))
(define IVTcds-neterm (nt IVTcds-eterm))

(pp IVTcds-neterm)

"[f0,n1,n2](cDC rat@@rat)(f0 doml@f0 domr)([n4]cIVTAux f0 n1(n2+n4))"

; We need ordinary successor induction, to prove thst [k]left(cds n+k)
; increases.  We derive it from the structural induction for pos by
; means of a general induction scheme for PosLt, called GInd in
; gcd.scm

; 04-09-09 Alternative: there is an obvious bijection nat <-> pos, and
; it should be easy to prove that under this bijection Succ ~ S, Zero
; ~ 1, NatLt ~ PosLt and so on.  Then ordinary successor induction
; for pos follows, and moreover we can transfer course-of-values
; induction over nat to pos, and prove GInd.  Rules for GInd can - as
; always - be provided as desired.

; (load "gcd.scm")

; (set-goal (pf "Q^ 1 -> (all n.Q^n -> Q^(S n)) -> all n Q^n"))
; (assume "QInit" "QStep" "n")
; (use-with "GInd"
; 	  (py "pos")
; 	  (make-cterm (pv "n") (pf "Q^n")) ;for QQ^
; 	  (pt "[n]n") ;for meas
;           (pt "[n]True") ;for dom
;           (pt "[n]n=1") ;for botGInd
;           "?" "?" "?" "?" (pt "n") "?" 
;           (pt "n=1") "?")
; (ng)
; (assume "m" "Triv1" "m=1" "k" "Triv2")
; (simp "m=1")
; (prop)
; (ng)
; (assume "m" "Triv1" "H1")
; (add-global-assumption
;  "PosSuccIndAux1" (pf "all m.(all k.k<m -> F) -> m=1"))
; (use "PosSuccIndAux1")
; (assume "k" "k<m")
; (use "H1" (pt "k"))
; (auto)

; (ng)
; (assume "m" "Triv1" "m=1")
; (simp "m=1")
; (use "QInit")

; (ng)
; (assume "m" "Triv1" "1<m" "H")
; (cut (pf "m=S(PosPred m)"))
; (assume "m=S(PosPred m)")
; (simp "m=S(PosPred m)")
; (use "QStep")
; (use "H")
; (auto)
; (add-global-assumption
;  "PosSuccIndAux2" (pf "all m.(m=1 -> F) -> PosPred m<m"))
; (use "PosSuccIndAux2")
; (use "1<m")
; (add-global-assumption
;  "PosSuccIndAux3" (pf "all m.(m=1 -> F) -> m=S(PosPred m)"))
; (use "PosSuccIndAux3")
; (use "1<m")
; (use "Truth-Axiom")
; (use "Truth-Axiom")

; (save "PosSuccInd")

; Here is the alternative:, previously in possuccind.scm

; There is an obvious bijection nat <-> pos, and it should be easy to
; prove that under this bijection Succ ~ S, Zero ~ 1, NatLt ~
; PosLt and so on.  Then ordinary successor induction for pos
; follows, and moreover we can transfer course-of-values induction
; over nat to pos, and prove GInd.  Rules for GInd can - as always -
; be provided as desired.

; (load "~/minlog/init.scm")

; (set! COMMENT-FLAG #f)
; (libload "numbers.scm")
; (set! COMMENT-FLAG #t)

(set-goal (pf "all pos pos+pos=SZero pos"))
(ind)
(use "Truth-Axiom")
(assume "pos" "IH")
(ng)
(use "IH")
(assume "pos" "IH")
(ng)
(simp "IH")
(use "Truth-Axiom")

(add-rewrite-rule (pt "pos+pos") (pt "SZero pos"))

; Notice that nat.scm and numbers.scm cannot reasonably coexist.  One
; reason is make-numeric term, another one that the token + would have
; to be extended in numbers.scm, with many consequences for coercion.
; So we use a fresh version of nat here.

(add-alg "nat" '("Zero" "nat") '("Succ" "nat=>nat"))

(add-program-constant "D" (py "nat=>nat") 1)

(add-computation-rule (pt "D Zero") (pt "Zero"))
(add-computation-rule (pt "D(Succ nat)") (pt "Succ(Succ(D nat))"))

(add-program-constant "NatPlus" (py "nat=>nat=>nat") 1)

(add-computation-rule (pt "NatPlus nat1 Zero") (pt "nat1"))
(add-computation-rule (pt "NatPlus nat1(Succ nat2)")
		      (pt "Succ(NatPlus nat1 nat2)"))

(set-goal (pf "all nat1,nat2 NatPlus(Succ nat1)nat2=Succ(NatPlus nat1 nat2)"))
(assume "nat1")
(ind)
(use "Truth-Axiom")
(assume "nat2" "IH")
(ng)
(use "IH")

(add-rewrite-rule (pt "NatPlus(Succ nat1)nat2") (pt "Succ(NatPlus nat1 nat2)"))

(set-goal (pf "all nat D nat=NatPlus nat nat"))
(ind)
(use "Truth-Axiom")
(assume "nat" "IH")
(ng)
(use "IH")

(add-rewrite-rule (pt "D nat") (pt "NatPlus nat nat"))

(add-program-constant "NatToPos" (py "nat=>pos") 1)
(add-program-constant "PosToNat" (py "pos=>nat") 1)

(add-computation-rule (pt "NatToPos Zero") (pt "One"))
(add-computation-rule (pt "NatToPos(Succ nat)") (pt "S(NatToPos nat)"))

(add-computation-rule (pt "PosToNat One") (pt "Zero"))
(add-computation-rule (pt "PosToNat(SZero pos)") (pt "Succ(D(PosToNat pos))"))
(add-computation-rule (pt "PosToNat(SOne pos)") (pt "D(Succ(PosToNat pos))"))

; (pp (nt (pt "NatToPos(PosToNat 1000)")))

(set-goal (pf "all pos PosToNat(S pos)=Succ(PosToNat pos)"))
(ind)
(use "Truth-Axiom")

(assume "pos" "IH")
(ng)
(use "Truth-Axiom")

(assume "pos" "IH")
(ng)
(simp "IH")
(ng)
(use "Truth-Axiom")

(add-rewrite-rule (pt "PosToNat(S pos)") (pt "Succ(PosToNat pos)"))

(set-goal (pf "S(NatToPos(NatPlus nat nat))=NatToPos nat + NatToPos nat"))
(ind)
(ng)
(prop)

(assume "nat" "IH")
(ng)
(simp "IH")
(prop)

(add-rewrite-rule (pt "S(NatToPos(NatPlus nat nat))")
		  (pt "NatToPos nat + NatToPos nat"))

; Now we prove that NatToPos and PosToNat are bijections:

(set-goal (pf "all pos NatToPos(PosToNat pos)=pos"))
(ind)
(ng)
(use "Truth-Axiom")

(assume "pos" "IH")
(ng)
(simp "IH")
(use "Truth-Axiom")

(assume "pos" "IH")
(ng)
(use "IH")

(set-goal (pf "all nat PosToNat(NatToPos nat)=nat"))
(ind)
(use "Truth-Axiom")

(assume "nat" "IH")
(ng)
(use "IH")

(add-rewrite-rule (pt "NatToPos(PosToNat pos)") (pt "pos"))
(add-rewrite-rule (pt "PosToNat(NatToPos nat)") (pt "nat"))

; We now transfer successor induction from nat to pos:

; (add-pvar-name "Q" (make-arity (py "pos")))

(set-goal (pf "Q^One -> (all pos.Q^pos -> Q^(S pos)) -> all pos Q^pos"))
(assume "QInit" "QStep")
(assert (pf "all nat Q^(NatToPos nat)"))
 (ind)
 (use "QInit")
 (assume "nat" "IH")
 (use "QStep")
 (use "IH")
(assume "H" "pos")
(use-with "H" (pt "PosToNat pos"))

(save "PosSuccInd")

(pp (proof-to-extracted-term
     (theorem-name-to-proof "PosSuccInd")))

; End of the previous possuccind.scm


; We now prove that [k]left(cds n+k) increases.

; "IVTLeftIncr"
(set-goal 
 (pf "all f,l,k0.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (1#exp 2(k0+1))<=f domr-f doml ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->     
     all cds.Equal(cds 1)(f doml@f domr) &
             all n Corr f(left(cds n))(right(cds n))(k0+n) &
             (all n.left(cds n)<=left(cds(S n)) & 
                    right(cds(S n))<=right(cds n) &
                    right(cds(S n))-left(cds(S n))=
                    (2#3)*(right(cds n)-left(cds n))) ->
             all n,k.left(cds n)<=left(cds(n+k))"))             
(assume "f" "l" "k0" "Cont f" "f a<<=0" "0<<=f b" "a <_k0 b" "HypSlope"
	"cds" "Hcds" "n")
(use-with  "PosSuccInd"
	   (make-cterm (pv "k") (pf "left(cds n)<=left(cds(n+k))")) "?" "?")

; Base
(search)

; Step
(assume "k" "IHk")
(use "RatLeTrans" (pt "left(cds(n+k))"))
(auto)

(save "IVTLeftIncr")

; The corresponding proof of d(n+k)<=dn:

; "IVTRightDecr"
(set-goal 
 (pf "all cds.(all n.right(cds(S n))<=right(cds n)) ->
              all n,k.right(cds(n+k))<=right(cds n)"))
(assume "cds" "Step" "n")
(use-with  "PosSuccInd"
	   (make-cterm (pv "k") (pf "right(cds(n+k))<=right(cds n)")) "?" "?")

; Base
(search)

; Step
(assume "k" "IHk")
(use "RatLeTrans" (pt "right(cds(n+k))"))
(auto)

(save "IVTRightDecr")


; A streamlined proof of dn-cn=(2/3)^n (b-a).  We use RatExp for (2/3)^n

(set-goal  (pf "all n1,n2,m.n1=n2 -> (n1#m)=(n2#m)"))
(auto)

(set-goal  (pf "all n,m1,m2.m1=m2 -> (n#m1)=(n#m2)"))
(auto)

(display-program-constants "RatTimes")
(display-program-constants "RatExp")

; to be moved into numbers.scm
(add-computation-rule (pt "exp a(SZero n)") (pt "exp a n*exp a n"))
(add-computation-rule (pt "exp a(SOne n)") (pt "exp a n*exp a n*a"))

(set-goal (pf "all a,n.exp(exp a 2)n=exp a(2*n)"))
(assume "a")
(ind)
(use "Truth-Axiom")
(assume "n" "IHn")
(ng)
(simp "IHn")
(use "Truth-Axiom")
(assume "n" "IHn")
(ng)
(simp "IHn")
(ord-field-simp-bwd)

; But notice: exp(exp a 2)n=exp a(2*n) provable by ord-field-simp-bwd directly

; Now what we wanted to do:

; "IVTDiff"
(set-goal 
 (pf "all f,cds.Equal(cds 1)(f doml@f domr) ->
                (all n right(cds(S n))-left(cds(S n))=
                       (2#3)*(right(cds n)-left(cds n))) ->
                all n (2#3)*(right(cds n)-left(cds n))=
                      exp(2#3)n*(f domr-f doml)"))
(assume "f" "cds" "EqOne" "Step")
(use-with  "PosSuccInd"
	   (make-cterm (pv "n") (pf "(2#3)*(right(cds n)-left(cds n))=
                      exp(2#3)n*(f domr-f doml)")) "?" "?")

; Base
(simp "EqOne")
(use "Truth-Axiom")

; Step
(assume "n" "IHn")
(cut (pf "right(cds(S n))-left(cds(S n))=
          (2#3)*(right(cds n)-left(cds n))"))
(assume "H")
(simp "H")
(simp "IHn")
; (display-program-constants "RatTimes")
(ord-field-simp-bwd)
(use "Step")

; (remove-theorem "IVTDiff")
(save "IVTDiff")

; Proof that (left(cds n)) is a Cauchy sequence with modulus 2*(k+k0)

; (add-global-assumption
;  "RatMinusLe2"
;  (pf "all a1,a2,b1,b2.a1<=a2 -> b2<=b1 -> a1-b1<=a2-b2"))

; We will need a general criterion for Cauchyness, in order to avoid
; doing a symmetric argument twice, in a concrete case.  To be called
; CauchyCrit.

(add-global-assumption "RatAbsSymm" (pf "all a,b.abs(a-b)==abs(b-a)"))
(add-global-assumption "RatAbsNNeg" (pf "all a.0<=a -> abs a==a"))
(add-global-assumption "RatAbsNPos" (pf "all a,b.a<=b -> abs(a-b)==b-a"))

(display-program-constants "PosLe")

; PosLe
;   comprules
; 	1<=n	True
; 	SZero n<=1	False
; 	SOne n<=1	False
; 	SZero n<=SZero m	n<=m
; 	SZero n<=SOne m	n<=m
; 	SOne n<=SZero m	n<m
; 	SOne n<=SOne m	n<=m
;   rewrules
; 	n<=n	True
; 	n<=S n	True
; 	S n<=n	False
; 	n<=n+m	True
; 	S n<=S m	n<=m
; 	S n<=1	False

; To work with PosSuccInd, add the rewrite rules
; (add-rewrite-rule (pt "S n<=S m") (pt "n<=m"))
; (add-rewrite-rule (pt "S n<=1") (pt "False"))

(display-program-constants "PosLt")

; PosLt
;   comprules
; 	n<1	False
; 	1<SZero n	True
; 	1<SOne n	True
; 	SZero n<SZero m	n<m
; 	SZero n<SOne m	n<=m
; 	SOne n<SZero m	n<m
; 	SOne n<SOne m	n<m
;   rewrules
; 	n<n	False
; 	n<S n	True
; 	S n<n	False
; 	n<n+m	True
; 	S n<S m	n<m
; 	1<S n	True

; To work with PosSuccInd, add the rewrite rules
; (add-rewrite-rule (pt "S n<S m") (pt "n<m"))
; (add-rewrite-rule (pt "1<S n") (pt "True"))

; "PosLeCases"
(set-goal (pf "all n,m.(n<=m -> Pvar^) -> (m<=n -> Pvar^) -> Pvar^"))
(use-with "PosSuccInd"
	  (make-cterm (pv "n")
		      (pf "all m.(n<=m -> Pvar^) -> (m<=n -> Pvar^) -> Pvar^"))
	  "?" "?")
(auto)
(assume "n" "IHn")
(use-with "PosSuccInd"
	  (make-cterm
	   (pv "m")
	   (pf "(S n<=m -> Pvar^) -> (m<=S n -> Pvar^) -> Pvar^"))
	  "?" "?")
(auto)
(save "PosLeCases")


; "CauchyCrit"
(set-goal
 (pf "all as,M.(all k,n,m.M k<=n -> n<=m ->
                          abs(as n-as m)<=(1#exp 2 k)) ->
               Cauchy as M"))
(assume "as" "M" "Hyp")
(use "CauchyIntro")

; ?_3: all k,n,m.M k<=n -> M k<=m -> abs(as n-as m)<=(1#exp 2 k)
(assume "k" "n" "m" "M k<=n" "M k<=m")
(use "PosLeCases" (pt "n") (pt "m"))

; ?_5: n<=m -> abs(as n-as m)<=(1#exp 2 k)
(assume "n<=m")
(auto)

; ?_6: m<=n -> abs(as n-as m)<=(1#exp 2 k)
(assume "m<=n")
(use "RatEqLe" (pt "abs(as m-as n)"))

; ?_9: abs(as n-as m)==abs(as m-as n)
(use "RatAbsSymm")
(auto)
(save "CauchyCrit")


; It is difficult to prove the result using (exp 2 n)#(exp 3 n).
; Reason: use of "all n (exp 2(2*n)#exp 3(2*n))<=(1#exp 2 n)"
; is impossible.  This due to the lack of confluence in the rewriting
; rules (which may be cured by completion).  Here is the culprit:
; consider exp n(2*(m+k)), with the rewrite rules 2*l -> l+l,
; associativity to the left for +, exp n(2*m) -> exp(exp n 2)m.  Then
; exp n(2*(m+k)) -> exp(exp n 2)(m+k) and also -> exp n(m+k+m+k).

; Therefore we now try RatExp (which, however, will finally lead to
; the very same problem; see below)

; One more auxiliary goal, for computing with powers of 2/3

(add-global-assumption
 "PosExpDefS" (pf "all n,m exp n(S m)=n*exp n m"))

; "RatExpHalfAux"
(set-goal (pf "all n exp(1#2)n=(1#exp 2 n)"))
(use-with  "PosSuccInd"
	   (make-cterm (pv "n") (pf "exp(1#2)n=(1#exp 2 n)")) "?" "?")
(use "Truth-Axiom")
(assume "n" "IHn")
(cut (pf "exp(1#2)(S n)=(1#2)*exp(1#2)n"))
(assume "Hyp")
(simp "Hyp")
(cut (pf "exp 2(S n)=2*exp 2 n"))
(assume "HYP2")
(simp "HYP2")
(simp "IHn")
(use "Truth-Axiom")
(use "PosExpDefS")
(ord-field-simp-bwd)
(save "RatExpHalfAux")

; (display-program-constants "RatExp")
; (display-program-constants "PosExp")

(add-rewrite-rule (pt "exp a(m+m)") (pt "exp(exp a 2)m"))
(add-rewrite-rule (pt "exp a k*exp b k") (pt "exp(a*b)k"))
(add-global-assumption
 "RatLeExp"
 (pf "all a1,a2,m1,m2.0<a2 -> a1<=a2 -> m1<=m2-> exp a1 m1<=exp a2 m2"))

; Once again
(set-goal (pf "all n exp(2#3)(2*n)<=(1#exp 2 n)"))
(assume "n")
(ng)
(use "RatLeEq" (pt "exp(1#2)n"))
(use "RatLeExp")
(auto)
(cut (pf "exp(1#2)n=(1#exp 2 n)"))
(assume "EqHyp")
(simp "EqHyp")
(use "Truth-Axiom")
(use "RatExpHalfAux")

; Was:
; (set-goal
;  (pf "all n ((exp 2(2*n)#0)#exp 3(2*n))<=(1#exp 2 n)"))
; (assume "n")
; (add-rewrite-rule (pt "exp n(m+m)") (pt "exp(exp n 2)m"))
; (ng)
; (add-rewrite-rule (pt "exp n k*exp m k") (pt "exp(n*m)k"))
; (ng)
; (add-global-assumption
;  "PosLeExp"
;  (pf "all n1,n2,m1,m2.0<n2 -> n1<=n2 -> m1<=m2-> exp n1 m1<=exp n2 m2"))
; (use "PosLeExp")
; (auto)
(save "IVTCauchyAux")

(display-theorems "IVTCauchyAux")
; IVTCauchyAux	all n exp(4#9)n<=(1#exp 2 n)  same problem:
; exp(2#3)(2*n) is not left intact.
; (remove-theorem "IVTCauchyAux")

; One solution: switch off rewrite rules
; 	S n*m	n*m+m
; 	n*(m+k)	n*m+n*k

; (display-program-constants "RatExp")
;   comprules
; 	exp a 1	a
; 	exp a(SZero n)	exp a n*exp a n
; 	exp a(SOne n)	exp a n*exp a n*a
;   rewrules
; 	exp a(m+m)	exp(exp a 2)m

(display-global-assumptions "RatEqLe")

; 04-02-04 Another try, blocking rewrite rules using variables

(set-goal
 (pf "all a.a=(2#3) -> all n exp a(2*n)<=(1#exp 2 n)"))
(assume "a" "aDef" "n")

; (display-program-constants "RatExp")

(use "RatLeEq" (pt "exp(1#2)n"))
(simp "aDef")
(ng)

; ?_6: exp(4#9)n<=exp(1#2)n
(use "RatLeExp")
(auto)
(cut (pf "exp(1#2)n=(1#exp 2 n)"))
(assume "EqHyp")
(simp "EqHyp")
(use "Truth-Axiom")
(use "RatExpHalfAux")
(save "IVTCauchyAux1")

(display-theorems "IVTCauchyAux1")


; "IVTRealLeft"
(set-goal 
 (pf "all a,b,k1.
     b-a<=exp 2 k1 ->
     all cds.(all n,m.n<=m -> left(cds n)<=left(cds m)) ->
             (all n,m.n<=m -> right(cds m)<=right(cds n)) ->
             all n left(cds n)<=right(cds n) ->
             (all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(b-a)) ->
             Real(RealConstr([n]left(cds n))([k]2*(k+k1+1)))"))           
(assume "a" "b" "k1" "IntBound" "cds" "cIncr" "dDecr" "cs<=ds" "cdDiff")
(use "RealIntro")

; Cauchyness
(use "CauchyCrit")
(ng)

; ?_6: all k,n,m.SZero(S(k+k1))<=n -> n<=m -> abs(left(cds n)-left(cds m))<=(1#exp 2 k)
(assume "k" "n" "m" "Mk<=n" "n<=m")

; ?_7: abs(left(cds n)-left(cds m))<=(1#exp 2 k)
(use "RatEqLe" (pt "left(cds m)-left(cds n)"))

; ?_8: abs(left(cds n)-left(cds m))==left(cds m)-left(cds n)
(use "RatAbsNPos")
(auto)

; ?_9: left(cds m)-left(cds n)<=(1#exp 2 k)
(use "RatLeTrans" (pt "right(cds m)-left(cds n)"))

; ?_11: left(cds m)-left(cds n)<=right(cds m)-left(cds n)
(use "RatMinusLe2")
(auto)

; ?_12: right(cds m)-left(cds n)<=(1#exp 2 k)
(use "RatLeTrans" (pt "right(cds n)-left(cds n)"))

; ?_15: right(cds m)-left(cds n)<=right(cds n)-left(cds n)
(use "RatMinusLe2")
(auto)

; ?_16: right(cds n)-left(cds n)<=(1#exp 2 k)
(inst-with-to "cdDiff" (pt "n") "cdDiffn")
(add-global-assumption
 "IVTRealAux1"
 (pf "all a,b,c,d,n,k,k1.b-a<=exp 2 k1 -> SZero(S(k+k1))<=n -> 
                         (2#3)*(d-c)=exp(2#3)n*(b-a) ->
                         d-c<=(1#exp 2 k)"))
; Proof: d-c <  2*(2#3)*(d-c)
;            =  2*exp(2#3)n*(b-a)
;            <= 2*exp(2#3)n*exp 2 k1
;            <= 2*exp(2#3)(SZero(S(k+k1)))*exp 2 k1
;            <  2*exp(1#2)(S(k+k1))*exp 2 k1
;            =  exp(1#2)k
(use "IVTRealAux1" (pt "a") (pt "b") (pt "n") (pt "k1"))
(auto)

; ?_4: Mon((RealConstr([n]left(cds n))([k]2*(k+k1+1)))mod)
(ng)

; ?_24: Mon([n2]SZero(S(n2+k1)))
(use "MonIntro")
(ng)

; ?_26: all n,m.n<=m -> n+k1<=m+k1
(add-global-assumption
 "PosLePlus"
 (pf "all n1,n2,m1,m2.n1<=n2 -> m1<=m2 -> n1+m1<=n2+m2"))
(strip)
(use "PosLePlus")
(auto)
(save "IVTRealLeft")


; The final goal, split into parts:

; "IVTFinalRealLeft"
(set-goal 
 (pf "all f,l,k0,k1.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (1#exp 2 k0)<=f domr-f doml -> f domr-f doml<=exp 2 k1 ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->
     all cds.Equal(cds 1)(f doml@f domr) -> 
             all n Corr f(left(cds n))(right(cds n))(k0+n) -> 
             all n left(cds n)<=left(cds(S n)) -> 
             all n right(cds(S n))<=right(cds n) -> 
             all n right(cds(S n))-left(cds(S n))=
                     (2#3)*(right(cds n)-left(cds n)) ->
     Real(RealConstr([n]left(cds n))([k]2*(k+k1+1)))"))
(assume "f" "l" "k0" "k1" "Cont f" "f a<<=0" "0<<=f b"
	"a <_k0 b" "b-a<=exp 2 k1" "HypSlope" 
        "cds" "cdsProp1" "cdsProp2" "cdsProp3" "cdsProp4" "cdsProp5")
(use "IVTRealLeft" (pt "f doml") (pt "f domr"))
(use "b-a<=exp 2 k1")

; ?_4: all n,m.n<=m -> left(cds n)<=left(cds m)
(add-global-assumption
 "IVTFinalAux1"
 (pf "all cs.all n cs n<=cs(S n) -> all n,m.n<=m -> cs n<=cs m"))
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux1" (pt "[n]left(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(use "cdsProp3")

; ?_5: all n,m.n<=m -> right(cds m)<=right(cds n)
(add-global-assumption
 "IVTFinalAux2"
 (pf "all ds.all n ds(S n)<=ds n -> all n,m.n<=m -> ds m<=ds n"))
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux2" (pt "[n]right(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(use "cdsProp4")

; ?_6: all n left(cds n)<=right(cds n)
(add-global-assumption
 "IVTFinalAux3"
 (pf "all f,c,d,n.Corr f c d n -> c<=d"))
(assume "n")
(cut (pf "Corr f(left(cds n))(right(cds n))(k0+n)"))
(assume "CorrHyp")
(use-with "IVTFinalAux3" (pt "f") (pt "(left(cds n))") (pt "right(cds n)")
	  (pt "k0+n") "CorrHyp")
(use "cdsProp2")

; ?_7: all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(f domr-f doml)
; Here we need IVTDiff (display-theorems "IVTDiff")
(use "IVTDiff")
(use "cdsProp1")
(use "cdsProp5")
(save "IVTFinalRealLeft")


; "IVTRealAppLeft"
(set-goal 
 (pf "all f,l,k0,k1.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (1#exp 2 k0)<=f domr-f doml -> f domr-f doml<=exp 2 k1 ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->
     all cds.Equal(cds 1)(f doml@f domr) -> 
             all n Corr f(left(cds n))(right(cds n))(k0+n) -> 
             all n left(cds n)<=left(cds(S n)) -> 
             all n right(cds(S n))<=right(cds n) -> 
             all n right(cds(S n))-left(cds(S n))=
                     (2#3)*(right(cds n)-left(cds n)) ->
     Real(f(RealConstr([n]left(cds n))([k]2*(k+k1+1))))"))
(assume "f" "l" "k0" "k1" "Cont f" "f a<<=0" "0<<=f b"
	"a <_k0 b" "b-a<=exp 2 k1" "HypSlope" 
        "cds" "cdsProp1" "cdsProp2" "cdsProp3" "cdsProp4" "cdsProp5")
(add-global-assumption
 "ContAppReal"
 (pf "all f,x.Cont f -> Real x -> 
              all n f doml<=x seq n -> all n x seq n<=f domr -> Real(f x)"))
(use "ContAppReal")
(auto)
(use  "IVTFinalRealLeft" (pt "f") (pt "l") (pt "k0"))
(auto)

; ?_5: all n f doml<=(RealConstr([n]left(cds n))([k]2*(k+k1+1)))seq n
(assume "n")
(use "CorrElim1" (pt "right(cds n)") (pt "k0+n"))
(ng)
(auto)

; ?_6: all n (RealConstr([n]left(cds n))([k]2*(k+k1+1)))seq n<=f domr
(assume "n")
(ng)
(use "RatLeTrans" (pt "right(cds n)"))
(display-global-assumptions "IVTFinalAux3")
(use "IVTFinalAux3" (pt "f") (pt "k0+n"))
(auto)
(use "CorrElim2" (pt "left(cds n)") (pt "k0+n"))
(auto)
(save "IVTRealAppLeft")

; Similary for right:

; "IVTRealRight"
(set-goal 
 (pf "all a,b,k1.
     b-a<=exp 2 k1 ->
     all cds.(all n,m.n<=m -> left(cds n)<=left(cds m)) ->
             (all n,m.n<=m -> right(cds m)<=right(cds n)) ->
             all n left(cds n)<=right(cds n) ->
             (all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(b-a)) ->
             Real(RealConstr([n]right(cds n))([k]2*(k+k1+1)))"))           
(assume "a" "b" "k1" "IntBound" "cds" "cIncr" "dDecr" "cs<=ds" "cdDiff")
(use "RealIntro")

; Cauchyness
(use "CauchyCrit")
(ng)

; ?_6: all k,n,m.SZero(S(k+k1))<=n -> n<=m -> abs(right(cds n)-right(cds m))<=(1#exp 2 k)
(assume "k" "n" "m" "Mk<=n" "n<=m")

; ?_7: abs(right(cds n)-right(cds m))<=(1#exp 2 k)
(use "RatEqLe" (pt "right(cds n)-right(cds m)"))

; ?_8: abs(right(cds n)-right(cds m))==right(cds n)-right(cds m)
(add-global-assumption
 "RatAbsPos"
 (pf "all a,b.a<=b -> abs(b-a)==b-a"))
(use "RatAbsPos")
(auto)

; ?_9: right(cds n)-right(cds m)<=(1#exp 2 k)
(use "RatLeTrans" (pt "right(cds n)-left(cds m)"))

; ?_11: right(cds n)-right(cds m)<=right(cds n)-left(cds m)
(use "RatMinusLe2")
(auto)

; ?_12: right(cds n)-left(cds m)<=(1#exp 2 k)
(use "RatLeTrans" (pt "right(cds n)-left(cds n)"))

; ?_15: right(cds n)-left(cds m)<=right(cds n)-left(cds n)
(use "RatMinusLe2")
(auto)

; ?_16: right(cds n)-left(cds n)<=(1#exp 2 k)
(inst-with-to "cdDiff" (pt "n") "cdDiffn")
; (add-global-assumption
;  "IVTRealAux1"
;  (pf "all a,b,c,d,n,k,k1.b-a<=exp 2 k1 -> SZero(S(k+k1))<=n -> 
;                          (2#3)*(d-c)=exp(2#3)n*(b-a) ->
;                          d-c<=(1#exp 2 k)"))
; Proof: d-c <  2*(2#3)*(d-c)
;            =  2*exp(2#3)n*(b-a)
;            <= 2*exp(2#3)n*exp 2 k1
;            <= 2*exp(2#3)(SZero(S(k+k1)))*exp 2 k1
;            <  2*exp(1#2)(S(k+k1))*exp 2 k1
;            =  exp(1#2)k
(use "IVTRealAux1" (pt "a") (pt "b") (pt "n") (pt "k1"))
(auto)

; ?_4: Mon((RealConstr([n]left(cds n))([k]2*(k+k1+1)))mod)
(ng)

; ?_24: Mon([n2]SZero(S(n2+k1)))
(use "MonIntro")
(ng)

; ?_26: all n,m.n<=m -> n+k1<=m+k1
; (add-global-assumption
;  "PosLePlus"
;  (pf "all n1,n2,m1,m2.n1<=n2 -> m1<=m2 -> n1+m1<=n2+m2"))
(strip)
(use "PosLePlus")
(auto)
(save "IVTRealRight")


; "IVTFinalRealRight"
(set-goal 
 (pf "all f,l,k0,k1.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (1#exp 2 k0)<=f domr-f doml -> f domr-f doml<=exp 2 k1 ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->
     all cds.Equal(cds 1)(f doml@f domr) -> 
             all n Corr f(left(cds n))(right(cds n))(k0+n) -> 
             all n left(cds n)<=left(cds(S n)) -> 
             all n right(cds(S n))<=right(cds n) -> 
             all n right(cds(S n))-left(cds(S n))=
                     (2#3)*(right(cds n)-left(cds n)) ->
     Real(RealConstr([n]right(cds n))([k]2*(k+k1+1)))"))
(assume "f" "l" "k0" "k1" "Cont f" "f a<<=0" "0<<=f b"
	"a <_k0 b" "b-a<=exp 2 k1" "HypSlope" 
        "cds" "cdsProp1" "cdsProp2" "cdsProp3" "cdsProp4" "cdsProp5")
(use "IVTRealRight" (pt "f doml") (pt "f domr"))
(use "b-a<=exp 2 k1")

; ?_4: all n,m.n<=m -> left(cds n)<=left(cds m)
; (add-global-assumption
;  "IVTFinalAux1"
;  (pf "all cs.all n cs n<=cs(S n) -> all n,m.n<=m -> cs n<=cs m"))
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux1" (pt "[n]left(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(use "cdsProp3")

; ?_5: all n,m.n<=m -> right(cds m)<=right(cds n)
; (add-global-assumption
;  "IVTFinalAux2"
;  (pf "all ds.all n ds(S n)<=ds n -> all n,m.n<=m -> ds m<=ds n"))
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux2" (pt "[n]right(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(use "cdsProp4")

; ?_6: all n left(cds n)<=right(cds n)
; (add-global-assumption
;  "IVTFinalAux3"
;  (pf "all f,c,d,n.Corr f c d n -> c<=d"))
(assume "n")
(cut (pf "Corr f(left(cds n))(right(cds n))(k0+n)"))
(assume "CorrHyp")
(use-with "IVTFinalAux3" (pt "f") (pt "(left(cds n))") (pt "right(cds n)")
	  (pt "k0+n") "CorrHyp")
(use "cdsProp2")

; ?_7: all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(f domr-f doml)
; Here we need IVTDiff (display-theorems "IVTDiff")
(use "IVTDiff")
(use "cdsProp1")
(use "cdsProp5")
(save "IVTFinalRealRight")


; "IVTRealAppRight"
(set-goal 
 (pf "all f,l,k0,k1.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (1#exp 2 k0)<=f domr-f doml -> f domr-f doml<=exp 2 k1 ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->
     all cds.Equal(cds 1)(f doml@f domr) -> 
             all n Corr f(left(cds n))(right(cds n))(k0+n) -> 
             all n left(cds n)<=left(cds(S n)) -> 
             all n right(cds(S n))<=right(cds n) -> 
             all n right(cds(S n))-left(cds(S n))=
                     (2#3)*(right(cds n)-left(cds n)) ->
     Real(f(RealConstr([n]right(cds n))([k]2*(k+k1+1))))"))
(assume "f" "l" "k0" "k1" "Cont f" "f a<<=0" "0<<=f b"
	"a <_k0 b" "b-a<=exp 2 k1" "HypSlope" 
        "cds" "cdsProp1" "cdsProp2" "cdsProp3" "cdsProp4" "cdsProp5")
; (add-global-assumption
;  "ContAppReal"
;  (pf "all f,x.Cont f -> Real x -> 
;               all n f doml<=x seq n -> all n x seq n<=f domr -> Real(f x)"))
(use "ContAppReal")
(auto)
(use  "IVTFinalRealRight" (pt "f") (pt "l") (pt "k0"))
(auto)

; ?_5: all n f doml<=(RealConstr([n]right(cds n))([k]2*(k+k1+1)))seq n
(assume "n")
(ng)
(use "RatLeTrans" (pt "left(cds n)"))
(use "CorrElim1" (pt "right(cds n)") (pt "k0+n"))
(auto)
(display-global-assumptions "IVTFinalAux3")
(use "IVTFinalAux3" (pt "f") (pt "k0+n"))
(auto)

; ?_6: all n (RealConstr([n]right(cds n))([k]2*(k+k1+1)))seq n<=f domr
(assume "n")
(ng)
(use "CorrElim2" (pt "left(cds n)") (pt "k0+n"))
(auto)
(save "IVTRealAppRight")


; Now the final goal
; "IVTFinal"
(set-goal 
 (pf "all f,l,k0,k1.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (1#exp 2 k0)<=f domr-f doml -> f domr-f doml<=exp 2 k1 ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->     
     ex z.Real z & f z===0"))
(assume "f" "l" "k0" "k1" "Cont f" "f a<<=0" "0<<=f b"
	"a <_k0 b" "b-a<=exp 2 k1" "HypSlope")
(cut (pf "ex cds.Equal(cds 1)(f doml@f domr) & all n Corr f(left(cds n))(right(cds n))(k0+n) & (all n.left(cds n)<=left(cds(S n)) & right(cds(S n))<=right(cds n) & right(cds(S n))-left(cds(S n))=(2#3)*(right(cds n)-left(cds n)))"))
(assume "Excds")
(by-assume-with "Excds" "cds" "cdsProp")
(ex-intro (pt "RealConstr([n]left(cds n))([k]2*(k+k1+1))"))
(split)
(use  "IVTFinalRealLeft" (pt "f") (pt "l") (pt "k0"))
(auto)

; ?_11: f(RealConstr([n]left(cds n))([k]2*(k+k1+1)))===0
(add-global-assumption
 "RealLeAntiSymm"
 (pf "all x,y.Real x -> Real y -> x<<=y -> y<<=x -> x===y"))
(use "RealLeAntiSymm")

; ?_23: Real(f(RealConstr([n]left(cds n))([k]2*(k+k1+1))))
(use "IVTRealAppLeft" (pt "l") (pt "k0"))
(auto)

; ?_24: Real(0)
(add-global-assumption "RealZero" (pf "Real(0)"))
(use "RealZero")

; ?_25: f(RealConstr([n]left(cds n))([k]2*(k+k1+1)))<<=0
(add-global-assumption
 "LeContAppZero"
 (pf "all f,x.Cont f -> Real x -> all n f(x seq n)<<=0 -> f x<<=0"))
(use "LeContAppZero")
(use "Cont f")
(use  "IVTFinalRealLeft" (pt "f") (pt "l") (pt "k0"))
(auto)

; ?_53: all n f((RealConstr([n]left(cds n))([k]2*(k+k1+1)))seq n)<<=0
(assume "n")
(use "CorrElim4" (pt "right(cds n)") (pt "k0+n"))
(auto)

; ?_26: 0<<=f(RealConstr([n]left(cds n))([k]2*(k+k1+1)))
(add-global-assumption
 "RealLeZeroCompat"
 (pf "all x,y.Real x -> Real y -> x===y -> 0<<=y -> 0<<=x"))
(use "RealLeZeroCompat" (pt "f(RealConstr([n]right(cds n))([k]2*(k+k1+1)))"))

; ?_54: Real(f(RealConstr([n]left(cds n))([k]2*(k+k1+1))))
(use "IVTRealAppLeft" (pt "l") (pt "k0"))
(auto)

; ?_55: Real(f(RealConstr([n]right(cds n))([k]2*(k+k1+1))))
(use "IVTRealAppRight" (pt "l") (pt "k0"))
(auto)

; ?_56: f(RealConstr([n]left(cds n))([k]2*(k+k1+1)))===f(RealConstr([n]right(cds n))([k]2*(k+k1+1)))
(add-global-assumption
 "ContAppCompat"
 (pf "all f,x,y.Cont f -> Real x -> Real y -> x===y -> f x===f y"))
(use "ContAppCompat")
(auto)
(use "IVTRealLeft" (pt "f doml") (pt "f domr"))
(auto)

; ?_85: all n,m.n<=m -> left(cds n)<=left(cds m)
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux1" (pt "[n]left(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(auto)

; ?_86: all n,m.n<=m -> right(cds m)<=right(cds n)
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux2" (pt "[n]right(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(auto)

; ?_87: all n left(cds n)<=right(cds n)
(assume "n")
(cut (pf "Corr f(left(cds n))(right(cds n))(k0+n)"))
(assume "CorrHyp")
(use-with "IVTFinalAux3" (pt "f") (pt "(left(cds n))") (pt "right(cds n)")
	  (pt "k0+n") "CorrHyp")
(auto)

; ?_88: all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(f domr-f doml)
; Here we need IVTDiff (display-theorems "IVTDiff")
(use "IVTDiff")
(auto)

; ?_82: Real(RealConstr([n]right(cds n))([k]2*(k+k1+1)))
(use "IVTRealRight" (pt "f doml") (pt "f domr"))
(auto)

; ?_102: all n,m.n<=m -> left(cds n)<=left(cds m)
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux1" (pt "[n]left(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(auto)

; ?_103: all n,m.n<=m -> right(cds m)<=right(cds n)
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux2" (pt "[n]right(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(auto)

; ?_104: all n left(cds n)<=right(cds n)
(assume "n")
(cut (pf "Corr f(left(cds n))(right(cds n))(k0+n)"))
(assume "CorrHyp")
(use-with "IVTFinalAux3" (pt "f") (pt "(left(cds n))") (pt "right(cds n)")
	  (pt "k0+n") "CorrHyp")
(auto)

; ?_105: all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(f domr-f doml)
; Here we need IVTDiff (display-theorems "IVTDiff")
(use "IVTDiff")
(auto)

; ?_83: RealConstr([n]left(cds n))([k]2*(k+k1+1))===RealConstr([n]right(cds n))([k]2*(k+k1+1))
(use "RealEqChar2")

; ?_118: Cauchy([n]left(cds n))([k]2*(k+k1+1))
(cut (pf "Real(RealConstr([n]left(cds n))([k]2*(k+k1+1)))"))
(use "RealElimVariant1")
(use "IVTRealLeft" (pt "f doml") (pt "f domr"))
(auto)

; ?_124: all n,m.n<=m -> left(cds n)<=left(cds m)
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux1" (pt "[n]left(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(auto)

; ?_125: all n,m.n<=m -> right(cds m)<=right(cds n)
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux2" (pt "[n]right(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(auto)

; ?_126: all n left(cds n)<=right(cds n)
(assume "n")
(cut (pf "Corr f(left(cds n))(right(cds n))(k0+n)"))
(assume "CorrHyp")
(use-with "IVTFinalAux3" (pt "f") (pt "(left(cds n))") (pt "right(cds n)")
	  (pt "k0+n") "CorrHyp")
(auto)

; ?_127: all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(f domr-f doml)
; Here we need IVTDiff (display-theorems "IVTDiff")
(use "IVTDiff")
(auto)

; ?_119: Cauchy([n]right(cds n))([k]2*(k+k1+1))
(cut (pf "Real(RealConstr([n]right(cds n))([k]2*(k+k1+1)))"))
(use "RealElimVariant1")
(use "IVTRealRight" (pt "f doml") (pt "f domr"))
(auto)

; ?_143: all n,m.n<=m -> left(cds n)<=left(cds m)
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux1" (pt "[n]left(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(auto)

; ?_144: all n,m.n<=m -> right(cds m)<=right(cds n)
(assume "n" "m" "n<=m")
(use-with "IVTFinalAux2" (pt "[n]right(cds n)") "?" (pt "n") (pt "m") "n<=m")
(ng)
(auto)

; ?_145: all n left(cds n)<=right(cds n)
(assume "n")
(cut (pf "Corr f(left(cds n))(right(cds n))(k0+n)"))
(assume "CorrHyp")
(use-with "IVTFinalAux3" (pt "f") (pt "(left(cds n))") (pt "right(cds n)")
	  (pt "k0+n") "CorrHyp")
(auto)

; ?_146: all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(f domr-f doml)
; Here we need IVTDiff (display-theorems "IVTDiff")
(use "IVTDiff")
(auto)

; ?_120: all k ex n0 all n.n0<=n -> abs(([n]left(cds n))n-([n]right(cds n))n)<=(1#exp 2 k)
(assume "k")
(ng)

; ?_160: ex n0 all n.n0<=n -> abs(left(cds n)-right(cds n))<=(1#exp 2 k)
(add-global-assumption
 "IVTFinalAux4"
 (pf "all f,cds.
      (all n (2#3)*(right(cds n)-left(cds n))=exp(2#3)n*(f domr-f doml)) ->
      all k ex n0 all n.n0<=n -> abs(left(cds n)-right(cds n))<=(1#exp 2 k)"))
; needs an additional assumption left(cds n)<=right(cds n) to be correct
(use "IVTFinalAux4" (pt "f"))
(use "IVTDiff")
(auto)

; ?_57: 0<<=f(RealConstr([n]right(cds n))([k]2*(k+k1+1)))
(add-global-assumption
 "LeZeroContApp"
 (pf "all f,y.Cont f -> Real y -> all n 0<<=f(y seq n) -> 0<<=f y"))
(use "LeZeroContApp")
(use "Cont f")
(use  "IVTFinalRealRight" (pt "f") (pt "l") (pt "k0"))
(auto)

; ?_166: all n 0<<=f((RealConstr([n]right(cds n))([k]2*(k+k1+1)))seq n)
(assume "n")
(display-theorems "CorrElim5")
(use "CorrElim5" (pt "left(cds n)") (pt "k0+n"))
(auto)

; ?_4: ex cds.Equal(cds 1)(f doml@f domr) & all n Corr f(left(cds n))(right(cds n))(k0+n) & (all n.left(cds n)<=left(cds(S n)) & right(cds(S n))<=right(cds n) & right(cds(S n))-left(cds(S n))=(2#3)*(right(cds n)-left(cds n)))
(use "IVTcds" (pt "l"))
(auto)

; ?_183: (1#exp 2(k0+1))<=f domr-f doml
(add-global-assumption
 "IVTFinalAux5"
 (pf "all k0,f.(1#exp 2 k0)<=f domr-f doml -> (1#exp 2(k0+1))<=f domr-f doml"))
(use "IVTFinalAux5")
(auto)
(save "IVTFinal")

(define IVTFinal-eterm
  (proof-to-extracted-term (theorem-name-to-proof "IVTFinal")))
(define IVTFinal-neterm (nt IVTFinal-eterm))
(pp IVTFinal-neterm)

; [f0,n1,n2,n3]RealConstr([n4]left(cIVTcds f0 n1 n2 n4))([n4]SZero(S(n4+n3)))


; For to extract an approximation of sqrt 2 we prove IVTApprox
; This needs RealApprox (in real.scm)

; "IVTApprox"
(set-goal 
 (pf "all f,l,k0,k1.Cont f -> f f doml<<=0 -> 0<<=f f domr ->
     (1#exp 2 k0)<=f domr-f doml -> f domr-f doml<=exp 2 k1 ->
     (all c,d,m.f doml<=c -> d<=f domr ->
                (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->     
     exnc z.Real z & f z===0 & all k ex c abs(c-z)<<=(1#exp 2 k)"))
(assume "f" "l" "k0" "k1" "Cont f" "f a<<=0" "0<<=f b"
	"a <_k0 b" "b-a<=exp 2 k1" "HypSlope")
(cut (pf "ex z.Real z & f z===0"))
(assume "ExHyp")
(by-assume-with "ExHyp" "z" "zProp")

; ?_8: exnc z.Real z & f z===0 & all k ex c abs(c-z)<<=1#exp 2 k
(exnc-intro (pt "z"))
(split)
(use "zProp")

; ?_11: all k ex c abs(c-z)<<=1#exp 2 k
(assume "k")
(use "RealApprox")
(use "zProp")

; ?_4: ex z.Real z & f z===0
(use "IVTFinal" (pt "l") (pt "k0") (pt "k1"))
(auto)
(save "IVTApprox")

(define IVTApprox-eterm
  (proof-to-extracted-term (theorem-name-to-proof "IVTApprox")))
(define IVTApprox-neterm (nt IVTApprox-eterm))
(pp IVTApprox-neterm)

"[f0,n1,n2,n3]cRealApprox(cIVTFinal f0 n1 n2 n3)"


; We now prove that every continuous monotone function with a lower
; bound on its slope has a continuous inverse.

(add-var-name "g" (make-alg "cont"))
(add-var-name "u" (make-alg "rat"))

(add-program-constant "Shift" (py "cont=>rat=>cont") 1)

(add-computation-rule
 (pt "Shift f u")
 (pt "ContConstr f doml f domr([a,n]f approx a n-u)f uMod f uModCont"))

(add-global-assumption
 "ShiftProp"
 (pf "all f,u,c.Cont f -> f doml<=c -> c<=f domr -> Shift f u c===f c-u"))

(add-global-assumption
 "ShiftPropRev"
 (pf "all f,u,c.Cont f -> f doml<=c -> c<=f domr -> f c-u===Shift f u c"))

(add-global-assumption
 "ContShift" (pf "all f,u.Cont f -> Cont(Shift f u)"))

; We will apply AC to "all u ex z.Real z & Shift f u z===0".  The left
; component of z is a Cauchy sequence, and the whole function is the
; approximation part of the continuous function to be constructed.

(add-global-assumption
 "AC" (pf "all alpha1^ ex alpha2^ (Pvar alpha1 alpha2)alpha1^alpha2^ ->
            ex alpha1=>alpha2^ all alpha1^ 
             (Pvar alpha1 alpha2)alpha1^(alpha1=>alpha2^alpha1^)"))

(add-global-assumption ;to be used instead of "IVTFinalAux4"
 "InvAux1" (pf "all a,b,k1,k,n.b-a<=exp 2 k1 -> 2*(k1+k)<=n -> 
                exp(2#3)n*(b-a)<=(1#exp 2 k)"))

(add-global-assumption
 "RealLeRefl"
 (pf "all x.Real x -> x<<=x"))

; "Inv"
(set-goal
 (pf "all f,l,k0,k1,a1,b1.
      Cont f ->
      f(f doml)<<=a1 ->
      b1<<=f(f domr) ->
      a1<b1 -> 
      (1#exp 2(k0+1))<=f domr-f doml -> 
      f domr-f doml<=exp 2 k1 -> 
      (all c,d,m.
        f doml<=c -> 
        d<=f domr -> (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->
      ex g.Cont g & a1==g doml & b1==g domr &
           (all y.a1<<=y -> y<<=b1 -> f(g y)===y) &
           (all x.f doml<<=x -> x<<=f domr -> g(f x)===x)"))
(assume "f" "l" "k0" "k1" "a1" "b1" "Cont f" "f a<=a1" "b1<=f b" "a1<b1"
	"a <_k0 b" "b-a<=exp 2 k1" "HypSlope")
(assert
 (pf "all u.a1<=u -> u<=b1 -> 
      ex cds.Equal(cds 1)((Shift f u)doml@(Shift f u)domr) &
            all n Corr(Shift f u)(left(cds n))(right(cds n))(k0+n) &
            all n.left(cds n)<=left(cds(S n)) & 
                  right(cds(S n))<=right(cds n) &
                  right(cds(S n))-left(cds(S n))=
                  (2#3)*(right(cds n)-left(cds n))"))
 (assume "u" "a1<=u" "u<=b1")
 (use "IVTcds" (pt "l") (pt "k0+1") (pt "k1"))
 (use "ContShift")
 (use "Cont f")

; ?_7: Shift f u(Shift f u)doml<<=0 from
 (add-global-assumption
  "InvAux2"
  (pf "all f,u.Cont f -> Shift f u(f doml)===(f doml-u)"))
 (simp (pf "(Shift f u)doml=f doml"))
 (add-global-assumption
  "RealEqLe"
  (pf "all x,y,z.x===y -> y<<=z -> x<<=z"))
 (use "RealEqLe" (pt "f f doml-u"))
 (use "ShiftProp")
 (auto)

; ?_19: f doml<=f domr ;should be part of the def on Cont
 (add-global-assumption
  "ContDom" (pf "all f.Cont f -> f doml<=f domr"))
 (use "ContDom")
 (auto)
 (ord-field-simp-bwd)
 (add-global-assumption
  "RealLeTrans"
  (pf "all x,y,z.Real x -> Real y -> Real z -> x<<=y -> y<<=z -> x<<=z"))
 (use "RealLeTrans" (rat-term-to-real-term (pt "a1")))
 (add-global-assumption
  "ContAppRat"
  (pf "all f,c.Cont f -> f doml<=c -> c<=f domr -> Real(f c)"))
 (use "ContAppRat")
 (auto)
 (use "ContDom")
 (auto)
 (add-global-assumption
  "RealRat" (pf "all a Real a"))
 (use "RealRat")
 (use "RealRat")
 (auto)
 (add-global-assumption
  "RatRealLe" (pf "all a,b.a<=b -> a<<=b"))
 (use "RatRealLe")
 (auto)

; ?_8: 0<<=Shift f u(Shift f u)domr
 (simp (pf "(Shift f u)domr=f domr"))
 (add-global-assumption
  "RealLeEq"
  (pf "all x,y,z.x<<=y -> y===z -> x<<=z"))
 (use "RealLeEq" (pt "f f domr-u"))
 (ord-field-simp-bwd)
 (use "RealLeTrans" (rat-term-to-real-term (pt "b1")))
 (use "RealRat")
 (use "RealRat")
 (use "ContAppRat")
 (auto)

; ?_43: f doml<=f domr
 (use "ContDom")
 (auto)
 (use "RatRealLe")
 (auto)

; ?_35: f f domr-u===Shift f u f domr 
 (use "ShiftPropRev")
 (auto)

; ?_48: f doml<=f domr
 (use "ContDom")
 (auto)

; ?_11: all c,d,m.
;        (Shift f u)doml<=c -> 
;        d<=(Shift f u)domr -> 
;        (1#exp 2 m)<=d-c -> RealLt(Shift f u c)(Shift f u d)(m+l)
(assume "c" "d" "m" "a<=c" "d<=b" "(1#exp 2 m)<=d-c")
(add-global-assumption
 "InvAux3"
 (pf "all f,u,c,d,n.Cont f -> RealLt(f c)(f d)n -> 
                    RealLt(Shift f u c)(Shift f u d)n"))
(use "InvAux3")
(auto)

; ?_3: (all u.
;        a1<=u -> 
;        u<=b1 -> 
;        ex cds.
;         Equal(cds 1)((Shift f u)doml@(Shift f u)domr) & 
;         all n Corr(Shift f u)(left(cds n))(right(cds n))(k0+n) & 
;         all n.
;          left(cds n)<=left(cds(S n)) & right(cds(S n))<=right(cds n) & 
;          right(cds(S n))-left(cds(S n))=(2#3)*(right(cds n)-left(cds n))) -> 
;      ex g.
;       Cont g & a1==g doml & b1==g domr & 
;       all y.a1<<=y -> y<<=b1 -> f(g y)===y & 
;       all x.f doml<<=x -> x<<=f domr -> g(f x)===x from
(assume "IVTcdsHyp")
(add-var-name "pcds" (py "rat=>pos=>rat@@rat")) ;parametized cds
(assert
 (pf "all u ex cds.
       a1<=u -> 
       u<=b1 ->        
        Equal(cds 1)((Shift f u)doml@(Shift f u)domr) & 
        all n Corr(Shift f u)(left(cds n))(right(cds n))(k0+n) & 
        all n.
         left(cds n)<=left(cds(S n)) & right(cds(S n))<=right(cds n) & 
         right(cds(S n))-left(cds(S n))=(2#3)*(right(cds n)-left(cds n))"))
 (assume "u")
; Here we could use cases on a1<=u etc, if we want to avoid IP.
; However, this would bring the cade distinctions in the extracted
; term.  On the other hand, IP is completely harmless for decidable
; premises.

(add-global-assumption
 "IP" (pf "(Pvar -> ex alpha^ (Pvar alpha)alpha^) -> 
           ex alpha^(Pvar -> (Pvar alpha)alpha^)"))
; Problem with alpha^ for cds.  Hence: alpha
(add-global-assumption
 "IPT" (pf "(Pvar -> ex alpha (Pvar alpha)alpha) -> 
            ex alpha.Pvar -> (Pvar alpha)alpha"))

(use-with
 "IPT" (py "pos=>rat@@rat")
 (make-cterm (pf "a1<=u"))
 (make-cterm (pv "cds")
	     (pf "u<=b1 -> 
     Equal(cds 1)((Shift f u)doml@(Shift f u)domr) & 
     all n Corr(Shift f u)(left(cds n))(right(cds n))(k0+n) & 
     all n.
      left(cds n)<=left(cds(S n)) & right(cds(S n))<=right(cds n) & 
      right(cds(S n))-left(cds(S n))=(2#3)*(right(cds n)-left(cds n))"))
 "?")
(assume "a1<=u")
(use-with
 "IPT" (py "pos=>rat@@rat")
 (make-cterm (pf "u<=b1"))
 (make-cterm (pv "cds")
	     (pf "
     Equal(cds 1)((Shift f u)doml@(Shift f u)domr) & 
     all n Corr(Shift f u)(left(cds n))(right(cds n))(k0+n) & 
     all n.
      left(cds n)<=left(cds(S n)) & right(cds(S n))<=right(cds n) & 
      right(cds(S n))-left(cds(S n))=(2#3)*(right(cds n)-left(cds n))"))
 "?")
(assume "u<=b1")
(use "IVTcdsHyp")
(auto)

(drop "IVTcdsHyp")
(assume "IVTcdsHAC")
(assert
 (pf "ex pcds
      all u.
  a1<=u -> 
  u<=b1 -> 
   Equal(pcds u 1)((Shift f u)doml@(Shift f u)domr) & 
   all n Corr(Shift f u)(left(pcds u n))(right(pcds u n))(k0+n) & 
   all n.
    left(pcds u n)<=left(pcds u(S n)) & right(pcds u(S n))<=right(pcds u n) & 
    right(pcds u(S n))-left(pcds u(S n))=
    (2#3)*(right(pcds u n)-left(pcds u n))"))
(add-global-assumption
 "ACT"
 (pf "all alpha1 ex alpha2 (Pvar alpha1 alpha2)alpha1 alpha2 -> 
      ex alpha1=>alpha2 
      all alpha1 (Pvar alpha1 alpha2)alpha1(alpha1=>alpha2 alpha1)"))
(use-with
 "ACT"
 (py "rat") (py "pos=>rat@@rat")
 (make-cterm
  (pv "u") (pv "cds")
  (pf "a1<=u -> 
               u<=b1 -> 
               Equal(cds 1)((Shift f u)doml@(Shift f u)domr) & 
               all n Corr(Shift f u)(left(cds n))(right(cds n))(k0+n) & 
               all n.
                left(cds n)<=left(cds(S n)) & right(cds(S n))<=right(cds n) & 
                right(cds(S n))-left(cds(S n))=
                (2#3)*(right(cds n)-left(cds n))"))
 "?")
(use "IVTcdsHAC")

(drop "IVTcdsHAC")
(assume "Expcds")
(by-assume-with "Expcds" "pcds" "Hpcds")
(ex-intro (pt "ContConstr a1 b1 ([u,n]left(pcds u n))
                          ([k]k1+f uModCont(k+l+2))([k]k+l+2)"))
(split)
(split)
(split)
(split)

; ?_80: Cont(ContConstr a1 b1
; ([u,n]left(pcds u n))([k]k1+f uModCont(k+l+2))([k]k+l+2)) 

; Now we must verify that the construction of g indeed gives a
; continuos function, following the informal proof.  However, all this
; will not affect the extracted term.  So for the moment we use (admit)

(admit)
(admit)
(admit)
(admit)
(admit)
(save "Inv")

(pp (nt (proof-to-extracted-term (theorem-name-to-proof "Inv"))))

; [f0,n1,n2,n3,a4,a5]
;  ContConstr a4 a5
;  ([a6,n7]
;    left((cACT rat pos=>rat@@rat)
;         ([a8]
;           (cIPT pos=>rat@@rat)
;           ((cIPT pos=>rat@@rat)
;            (cIVTcds
;             (ContConstr f0 doml f0 domr([a12,n13]f0 approx a12 n13-a8)
;              f0 uMod 
;              f0 uModCont)
;             n1 
;             n2)))
;         a6 
;         n7))
;  ([n6]n3+f0 uModCont(S(S(n6+n1))))
;  ([n6]S(S(n6+n1)))


; For to use "Inv" for numerical computations we prove InvApprox.
; This needs RealApprox (in real.scm)

; "InvApprox"
(set-goal 
 (pf "all f,l,k0,k1,a1,b1.
      Cont f ->
      f(f doml)<<=a1 ->
      b1<<=f(f domr) ->
      a1<b1 -> 
      (1#exp 2(k0+1))<=f domr-f doml -> 
      f domr-f doml<=exp 2 k1 -> 
      (all c,d,m.
        f doml<=c -> 
        d<=f domr -> (1#exp 2 m)<=d-c -> RealLt(f c)(f d)(m+l)) ->
      exnc g.Cont g & a1==g doml & b1==g domr &
             (all y.a1<<=y -> y<<=b1 -> f(g y)===y) &
             (all x.f doml<<=x -> x<<=f domr -> g(f x)===x) &
             all u.a1<=u -> u<=b1 -> all k ex c abs(c-g u)<<=(1#exp 2 k)"))
(assume "f" "l" "k0" "k1" "a1" "b1" "Cont f" "f a<=a1" "b1<=f b" "a1<b1"
	"a <_k0 b" "b-a<=exp 2 k1" "HypSlope")
(cut (pf "ex g.Cont g & a1==g doml & b1==g domr &
             (all y.a1<<=y -> y<<=b1 -> f(g y)===y) &
             (all x.f doml<<=x -> x<<=f domr -> g(f x)===x)"))
(assume "ExHyp")
(by-assume-with "ExHyp" "g" "gProp")

; ?_8: exnc g. ...
(exnc-intro (pt "g"))
(split)
(use "gProp")

; ?_11: all u.a1<=u -> u<=b1 -> all k ex c abs(c-g u)<<=1#exp 2 k 
(assume "u" "a1<=u" "u<=b1" "k")
(use "RealApprox")

; ?_13: Real(g u)
(use "ContReal")
(use "gProp")
(use "RealRat")
(use "RatRealLe")
(use "RatEqLe" (pt "a1"))
(add-global-assumption
 "RatEqSymm" (pf "all a,b.a==b -> b==a"))
(use "RatEqSymm")
(use "gProp")
(use "a1<=u")
(use "RatRealLe")
(use "RatLeEq" (pt "b1"))
(use "u<=b1")
(use "gProp")

; ?_4: ex g.
;       Cont g & a1==g doml & b1==g domr & 
;       all y.a1<<=y -> y<<=b1 -> f(g y)===y & 
;       all x.f doml<<=x -> x<<=f domr -> g(f x)===x
(use "Inv"  (pt "l") (pt "k0") (pt "k1"))
(auto)
(save "InvApprox")

(define InvApprox-eterm
  (proof-to-extracted-term (theorem-name-to-proof "InvApprox")))
(define InvApprox-neterm (nt InvApprox-eterm))
(pp InvApprox-neterm)

; [f0,n1,n2,n3,a4,a5,a6]
;  cRealApprox
;  (RealConstr((cInv f0 n1 n2 n3 a4 a5)approx a6)
;   ([n8](cInv f0 n1 n2 n3 a4 a5)uMod(S(S n8))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Brainstorming: necessary and useful properties of Real, Cont, Corr,
; Cauchy, Mon, RealNNeg, RealPos, RealLt, RealLe <<=

; "RealPlus"
(set-goal (pf "all x,y.Real x -> Real y -> Real(x+y)"))

; 04-06-05

(add-var-name "xs" (py "pos=>real"))

(add-ids (list (list "RealCauchy"
		     (make-arity (py "pos=>real") (py "pos=>pos"))))
	 '("all xs,M.all n Real(xs n) ->
                     (all k,n,m.M k<=n -> M k<=m ->
                                abs(xs n-xs m)<<=(1#exp 2 k)) ->
                     RealCauchy xs M" "RealCauchyIntro"))

; "RealCauchyElim1"
(set-goal (pf "all xs,M.RealCauchy xs M -> all n Real(xs n)"))
(assume "xs" "M")
(elim)
(search)
(save "RealCauchyElim1")

; "RealCauchyElim2"
(set-goal
 (pf "all xs,M.RealCauchy xs M -> 
               all k,n,m.M k<=n ->  M k<=m ->
                       abs(xs n-xs m)<<=(1#exp 2 k)"))
(assume "xs" "M")
(elim)
(search)
(save "RealCauchyElim2")

(add-ids
 (list (list "RealConv"
	     (make-arity (py "pos=>real") (py "real") (py "pos=>pos"))))
 '("all xs,x,M.all n Real(xs n) -> Real x -> 
               (all k,n.M k<=n -> abs(xs n-x)<<=(1#exp 2 k)) ->
               RealConv xs x M" "RealConvIntro"))

; "RealConvElim1"
(set-goal (pf "all xs,x,M.RealConv xs x M -> all n Real(xs n)"))
(assume "xs" "x" "M")
(elim)
(search)
(save "RealConvElim1")

; "RealConvElim2"
(set-goal (pf "all xs,x,M.RealConv xs x M -> Real x"))
(assume "xs" "x" "M")
(elim)
(search)
(save "RealConvElim2")

; "RealConvElim3"
(set-goal
 (pf "all xs,x,M.RealConv xs x M ->
                 all k,n.M k<=n -> abs(xs n-x)<<=(1#exp 2 k)"))
(assume "xs" "x" "M")
(elim)
(search)
(save "RealConvElim3")

; "RealLeChar1"
(set-goal
 (pf "all as,M,bs,N.Cauchy as M -> Cauchy bs N ->
                    RealConstr as M<<=RealConstr bs N ->
                    all k ex n0 all n.n0<=n -> as n<=bs n+(1#exp 2 k)")) 

; "RealLeChar2"
(set-goal
 (pf "all as,M,bs,N.Cauchy as M -> Cauchy bs N ->
                    (all k ex n0 all n.n0<=n -> as n<=bs n+(1#exp 2 k)) ->
                    RealConstr as M<<=RealConstr bs N")) 

; "RatCauchyConvMod"
(set-goal
 (pf "all as,M,k,n.Cauchy as M -> M k<=n ->
                   abs(as n-RealConstr as M)<<=(1#exp 2 k)"))

; "RealComplete"
(set-goal
 (pf "all xs,M.RealCauchy xs M -> 
               RealConv xs(RealConstr([n](xs n)seq((xs n)mod n))
                                     ([q]M(q+1)max(q+2)))
                        ([q]M(q+2)max(q+3))"))

; "RealCauchyConvMod"
(set-goal
 (pf "all xs,M,k,n.RealCauchy xs M -> M k<=n ->
                   abs(xs n-RealConstr([n](xs n)seq((xs n)mod n))
                                      ([q]M(q+1)max(q+2)))<<=(1#exp 2 k)"))

; "ContLim"
(set-goal
 (pf "all f,xs,M,y.Cont f -> RealCauchy xs M ->
       all p ex n0 all n.n0<=n -> 
       abs(f(xs n)-f(RealConstr([n](xs n)seq((xs n)mod n))
                               ([q]M(q+1)max(q+2))))<<=(1#exp 2 p)"))

; "RealNNegLim"
(set-goal
 (pf "all xs,M.RealCauchy xs M -> all n 0<<=(xs n) ->
               0<<=(RealConstr ([n](xs n)seq((xs n)mod n))
                              ([q]M(q+1)max(q+2)))"))

